/******************************************************************************/
/*  %W% %D% %T%  */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*  Pascal-Programm:     Vera Kell                 Aachen, 31.07.1989         */
/*                                                                            */
/*  ANSI-C  Version:     Raphael M. Grochtmann     Aachen, 31.08.1990         */
/*                                                                            */
/*                                                                            */
/******************************************************************************/



#include <stdio.h>

#include "ext.h"
#include "list.h"



static void BarryLLevelSort(pvertex qlist, matrixlevelarray levelmat, int *levcount)
	/* levelmat (und levcount) sind var-Parmater */
	/* Sortieren der Zustaende (qlist) innerhalb einer Ebene und Anzahl  */
	/* der Ueberschneidungen nach Sortierung zwischen akt. und nachf.    */
	/* Ebene (qcross) */
{
	int i, j, lhcount;
	matrixlevelarray levmat;
	pvertex ql;

	for (i = 1; i <= NMAX; i++)
		levelmat[i] = levmat[i] = NULL;
	*levcount = lhcount = 0;/* Anzahl der Zustaende der akt. Ebene, Anzahl von levmat */
	while (qlist != NULL) {
		(*levcount)++;
		if (qlist->barryleft == 0)
			levelmat[qlist->pos] = qlist;
		else {
			lhcount++;
			levmat[lhcount] = qlist;
		}
		qlist = qlist->vertsucc;
	}
	for (i = 1; i <= lhcount; i++)				/* Sortieren der Zustaende anhand des */
		for (j = 1; j <= lhcount - i; j++)		/* Baryzentrums (Bubblesort)          */
			if (levmat[j + 1]->barryleft <  levmat[j]->barryleft	|| 
				levmat[j + 1]->barryleft == levmat[j]->barryleft	&& 
				levmat[j + 1]->pos < levmat[j]->pos)	{
				ql = levmat[j + 1];
				levmat[j + 1] = levmat[j];
				levmat[j] = ql;
			}
			j = 1;
			for (i = 1; i <= lhcount; i++) {
				while (levelmat[j++] != NULL) 
					;
				j--;
				levelmat[j++] = levmat[i];
			}
			for (i = 1; i <= *levcount; i++)
				if (levelmat[i] != NULL) 
					levelmat[i]->pos = i;  /* !! */
} /*BarryLLevelSort*/



static void BarryRLevelSort(pvertex qlist, matrixlevelarray levelmat, int *levcount)
	/* levelmat (und levcount) sind var-Parmaeter */
	/* Sortieren der Zustaende (qlist) innerhalb einer Ebene und Anzahl  */
	/* der Ueberschneidungen nach Sortierung zwischen akt. und nachf.    */
	/* Ebene (qcross) */
{
	int i, j, lhcount;
	matrixlevelarray levmat;
	pvertex ql;

	for (i = 1; i <= NMAX; i++)
		levelmat[i] = levmat[i] = NULL;	/* levelmat: Zustaende der akt. Ebene, */
										/* levmat: Hilfsfeld ohne Zustaende mit barryleft =0 */
	*levcount = lhcount = 0;			/* Anzahl der Zustaende der akt. Ebene, Anzahl von levmat */
	while (qlist != NULL) {
		(*levcount)++;
		if (qlist->barryright == 0)
			levelmat[qlist->pos] = qlist;
		else
			levmat[++lhcount] = qlist;
		qlist = qlist->vertsucc;
	}
	for (i = 1; i <= lhcount; i++)				/* Sortieren der Zustaende anhand des */
		for (j = 1; j <= lhcount - i; j++)		/* Baryzentrums (Bubblesort)          */
			if (levmat[j + 1]->barryright <  levmat[j]->barryright	|| 
				levmat[j + 1]->barryright == levmat[j]->barryright	&& 
				levmat[j + 1]->pos < levmat[j]->pos)	{
				ql = levmat[j + 1];
				levmat[j + 1] = levmat[j];
				levmat[j] = ql;
			}
	j = 1;
	for (i = 1; i <= lhcount; i++) {
		while (levelmat[j++] != NULL)
			;
		j--;
		levelmat[j++] = levmat[i];
	}
	for (i = 1; i <= *levcount; i++)
		if (levelmat[i] != NULL)  
			levelmat[i]->pos = i;   /* !! */
} /*BarryRLevelSort*/



static void BarryFindLREdgeCrosses(matrixlevelarray levelmat, int levcount, int *levelcross, int *lcrossreal)
	/* levelmat (und levelcross, lcrossreal) sind Var-Parameter */
{
	int i, j;
	plist qpreci, qprecj;

	*levelcross = 0;			/* Anzahl der Ueberschneidungen */
    *lcrossreal = 0;			/* Anzahl der Ueberschneidungen ohne Ebenenkanten */
	for (i = 1; i <= levcount - 1; i++) {
		for (j = i + 1; j <= levcount; j++) {
			qpreci = levelmat[i]->pre;
			while (qpreci != NULL) {
				qprecj = levelmat[j]->pre;
				while (qprecj != NULL) {
					if (qpreci->edge->pos>qprecj->edge->pos) {
						if (qpreci->edge->q != -1  &&  qprecj->edge->q != -1) 
							(*lcrossreal)++;
						(*levelcross)++;
					}
					qprecj = qprecj->listsucc;
				}
				qpreci = qpreci->listsucc;
			}
		}
	}
} /*BarryFindLREdgeCrosses*/



static void BarryFindRLEdgeCrosses(matrixlevelarray levelmat, int levcount, int *levelcross, int *lcrossreal)
	/* levelmat (und levelcross, lcrossreal) sind Var-Paramter */
{
	int i, j;
	plist qsucci, qsuccj;

	*levelcross = 0;		/* Anzahl der Ueberschneidungen */
	*lcrossreal = 0;		/* Anzahl der Ueberschneidungen ohne Ebenenkanten */
	for (i = 1; i <= levcount - 1; i++) {
		for (j = i + 1; j <= levcount; j++) {
			qsucci = levelmat[i]->suc;
			while (qsucci != NULL) {
				qsuccj = levelmat[j]->suc;
				while (qsuccj != NULL) {
					if (qsucci->edge->pos>qsuccj->edge->pos) {
						if (levelmat[i]->q != -1  &&  levelmat[j]->q != -1) 
							(*lcrossreal)++;
						(*levelcross)++;
					}
					qsuccj = qsuccj->listsucc;
				}
				qsucci = qsucci->listsucc;
			}
		}
	}
} /*BarryFindRLEdgeCrosses*/




static void BarryLRPass(plevel *levlist, int *cross, int *crossreal, int *pass)
	/* Bestimme LR-Baryzentrum (Vorgaenger) aller Zustaende */
	/* Ueberschneidungen nach Links-Rechts-Schritt */
{
	int barryLR, number, count, qcross, qcrossreal;
	pvertex qliste;
	plist qprec;
	plevel levl;
	matrixlevelarray levmat;

	*cross = *crossreal = 0;
	levl = *levlist;						/* Liste der Ebenen */
	while (levl != NULL) {
		qcross = qcrossreal = 0;
		qliste = levl->qlist;			/* Liste der Zustaende einer Ebene */
		while (qliste != NULL) {
			number = 0;					/* Anzahl der Nachfolger */
			barryLR = 0;				/* Summe der Positionen der Nachfolger */
			qprec = qliste->pre;		/* Liste der Nachfolger eines Zustandes */
			while (qprec != NULL) {
				number++;
				barryLR = barryLR + qprec->edge->pos;
				qprec = qprec->listsucc;
			}
			if (number != 0)
				if (*pass <= 2)			/* LR-Baryzentrum eines Zustandes */
					qliste->barryleft = (double)barryLR / (double)number;
				else
					if (qliste->barryright != 0)
						qliste->barryleft = (qliste->barryright + ((double)barryLR / (double)number)) / 2.0;
					else
						qliste->barryleft = (double)barryLR / (double)number;
			else
				qliste->barryleft = 0;
			qliste = qliste->vertsucc;
		}
		BarryLLevelSort(levl->qlist, levmat, &count);
		/* Sortiert Zustaende einer Ebene nach LR-Baryzentrum (oder MW) und be-*/
		/* stimmt Ueberschneidungen zwischen aktueller und nachfolgender Ebene */
		BarryFindLREdgeCrosses(levmat, count, &qcross, &qcrossreal);
		/* Bestimme Ueberschneidungen */
		*levlist = levl;
		levl = levl->levsucc;
		*cross += qcross;
		*crossreal += qcrossreal;
	}
} /*BarryLRPass*/



static void BarryRLPass(plevel *levlist, int *cross, int *crossreal, int *pass)
	/* Bestimme RL-Baryzentrum (Nachfolger) aller Zustaende */
	/* Ueberschneidungen nach Rechts-Links-Schritt */
{
	int barryRL, number, count, qcross, qcrossreal;
	pvertex qliste;
	plist qsucc;
	plevel levl;
	matrixlevelarray levmat;

	*cross = *crossreal = 0;
	levl = *levlist;					/* Liste der Ebenen */
	while (levl != NULL) {
		qcross = qcrossreal = 0;
		qliste = levl->qlist;			/* Liste der Zustaende einer Ebene */
		while (qliste != NULL) {
			number = 0;					/* Anzahl der Vorgaenger */
			barryRL = 0;				/* Summe der Positionen der Vorgaenger */
			qsucc = qliste->suc;		/* Liste der Nachfolger eines Zustandes */
			while (qsucc != NULL) {
				number++;
				barryRL += qsucc->edge->pos;
				qsucc = qsucc->listsucc;
			}
			if (number != 0)
				if (*pass <= 2)			/* LR-Baryzentrum eines Zustandes */
					qliste->barryright = (double)barryRL / (double)number;
				else
					if (qliste->barryleft != 0)
						qliste->barryright = (qliste->barryleft + ((double)barryRL / (double)number)) / 2.0;
					else
						qliste->barryright = (double)barryRL / (double)number;
			else
				qliste->barryright = 0;
			qliste = qliste->vertsucc;
		}
		BarryRLevelSort(levl->qlist, levmat, &count);
		/* Sortiert Zustaende einer Ebene nach RL-Baryzentrum (oder MW) und be-*/
		/* stimmt Ueberschneidungen zwischen aktueller und nachfolgender Ebene */
		BarryFindRLEdgeCrosses(levmat, count, &qcross, &qcrossreal);
		/* Bestimme Ueberschneidungen */
		*levlist = levl;
		levl = levl->levprec;
		*cross += qcross;
		*crossreal += +qcrossreal;
	}
} /*BarryRLPass*/



static void BarryIILLevelSort(pvertex qlist, matrixlevelarray levelmat, int *levcount)
	/* levelmat (und levcount) sind Var-Paramter */
	/* Sortieren der Zustaende (qlist) innerhalb einer Ebene und Anzahl  */
	/* der Ueberschneidungen nach Sortierung zwischen akt. und nachf.    */
	/* Ebene (qcross) */
{
	int i, j, lhcount;
	matrixlevelarray levmat;
	pvertex ql;

	for (i = 1; i <= NMAX; i++) {
		levelmat[i] = NULL;
		levmat[i] = NULL;
	}
	*levcount = 0;			/* Anzahl der Zustaende der akt. Ebene */
	lhcount = 0;			/* Anzahl von levmat */
	while (qlist != NULL) {
		if (qlist->q != -1) {
			(*levcount)++;
			if (qlist->barryleft == 0)
				levelmat[qlist->pos] = qlist;
			else {
				lhcount++;
				levmat[lhcount] = qlist;
			}
		}
		qlist = qlist->vertsucc;
	}
	for (i = 1; i <= lhcount; i++)			/* Sortieren der Zustaende anhand des */
		for (j = 1; j <= lhcount - i; j++)		/* Baryzentrums (Bubblesort) */
			if (levmat[j + 1]->barryleft  < levmat[j]->barryleft  ||
				levmat[j + 1]->barryleft == levmat[j]->barryleft  &&
				levmat[j + 1]->pos < levmat[j]->pos) {
				ql = levmat[j+1];
				levmat[j+1] = levmat[j];
				levmat[j] = ql;
			}
	j = 1;
	for (i = 1; i <= lhcount; i++) {
		while (levelmat[j++] != NULL)
			;
		levelmat[j++] = levmat[i];
	}
	for (i = 1; i <= *levcount; i++)
		if (levelmat[i] != NULL) 
			levelmat[i]->pos = i;     /* !! */
} /*BarryIILLevelSort*/



static void BarryIIRLevelSort(pvertex qlist, matrixlevelarray levelmat, int *levcount)
	/* levelmat (und levcount) sind Var-Parameter */
	/* Sortieren der Zustaende (qlist) innerhalb einer Ebene und Anzahl  */
	/* der Ueberschneidungen nach Sortierung zwischen akt. und nachf.    */
	/* Ebene (qcross) */
{
	int i, j, lhcount;
	matrixlevelarray levmat;
	pvertex ql;

	for (i = 1; i <= NMAX; i++) {
		levelmat[i] = NULL;		/* levelmat: Zustaende der akt. Ebene */
		levmat[i] = NULL;		/* levmat: Hilfsfeld ohne Zustaende mit barryleft =0 */
	}
	*levcount = 0;				/* Anzahl der Zustaende der akt. Ebene */
	lhcount = 0;				/* Anzahl von levmat */
	while (qlist != NULL) {
		if (qlist->q == -1) {
			(*levcount)++;
			if (qlist->barryright == 0)
				levelmat[qlist->pos] = qlist;
			else
				levmat[++lhcount] = qlist;
		}
		qlist = qlist->vertsucc;
	}
	for (i = 1; i <= lhcount; i++)		/* Sortieren der Zustaende anhand des */
		for (j = 1; j <= lhcount - i; j++)		/* Baryzentrums (Bubblesort) */
			if (levmat[j + 1]->barryright <  levmat[j]->barryright  || 
				levmat[j + 1]->barryright == levmat[j]->barryright  && 
				levmat[j + 1]->pos < levmat[j]->pos) {
				ql = levmat[j + 1];
				levmat[j + 1] = levmat[j];
				levmat[j] = ql;
			}
	j = 1;
	for (i = 1; i <= lhcount; i++) {
		while (levelmat[j++] != NULL)
			;
		levelmat[j++] = levmat[i];
	}
	for (i = 1; i <= *levcount; i++)
		if (levelmat[i] != NULL)		/* !! */
			levelmat[i]->pos = i;
} /*BarryIIRLevelSort*/



static void BarryIIFindLREdgeCrosses(matrixlevelarray levelmat, int levcount, int *levelcross)
	/* levelmat (und levelcross) sind Var-Paramter */
{
	int i, j;
	plist qpreci, qprecj;

	*levelcross = 0;			/* Anzahl der Ueberschneidungen */
	for (i = 1; i <= levcount - 1; i++) {
		for (j = i + 1; j <= levcount; j++) {
			if (levelmat[i] != NULL) 
				qpreci = levelmat[i]->pre;	/* !! */
			else
				qpreci = NULL;
			while (qpreci != NULL) {
				if (levelmat[j] != NULL) 
					qprecj = levelmat[j]->pre;	/* !! */
				else
					qprecj = NULL;
				while (qprecj != NULL) {
					if (qpreci->edge->q != -1  &&  qprecj->edge->q != -1) 
						if (qpreci->edge->pos>qprecj->edge->pos)
							(*levelcross)++;
					qprecj = qprecj->listsucc;
				}
				qpreci = qpreci->listsucc;
			}
		}
	}
} /*BarryIIFindLREdgeCrosses*/



static void BarryIIFindRLEdgeCrosses(matrixlevelarray levelmat, int levcount, int *levelcross)
	/* levelmat (und levelcross) sind Var-Parameter */
{
	int i, j;
	plist qsucci, qsuccj;

	*levelcross = 0;			/* Anzahl der Ueberschneidungen */
	for (i = 1; i <= levcount - 1; i++) {
		for (j = i + 1; j <= levcount; j++) {
			if (levelmat[i] != NULL) 
				qsucci = levelmat[i]->suc;		/* !! */
			else
				qsucci = NULL;
			while (qsucci != NULL) {
				if (levelmat[j] != NULL) 
					qsuccj = levelmat[j]->suc;	/* !! */
				else
					qsuccj = NULL;
				while (qsuccj != NULL) {
					if (qsucci->edge->pos > qsuccj->edge->pos)
						(*levelcross)++;
					qsuccj = qsuccj->listsucc;
				}
				qsucci = qsucci->listsucc;
			}
		}
	}
} /*BarryIIFindRLEdgeCrosses*/



static void BarryIILRPass(plevel *levlist, int *cross, int *pass)
	/* Bestimme LR-Baryzentrum (Vorgaenger) aller Zustaende */
	/* Ueberschneidungen nach Links-Rechts-Schritt */
{
	int barryLR, number, count, qcross;
	pvertex qliste;
	plist qprec;
	plevel levl;
	matrixlevelarray levmat;

	*cross = 0;
	levl = *levlist;			/* Liste der Ebenen */
	while (levl != NULL) {
		qcross = 0;
		qliste = levl->qlist;		/* Liste der Zustaende einer Ebene */
		if (*pass == 1)
			BarryIILLevelSort(qliste, levmat, &count);
		while (qliste != NULL) {
			if (qliste->q != -1) {
				number = 0;				/* Anzahl der Nachfolger */
				barryLR = 0;			/* Summe der Positionen der Nachfolger */
				qprec = qliste->pre;	/* Liste der Nachfolger eines Zustandes */
				while (qprec != NULL) {
					if (qprec->edge->q != -1) {
						number++;
						barryLR += qprec->edge->pos;
					}
					qprec = qprec->listsucc;
				}
				if (number != 0)
					if (*pass <= 2)		/* LR-Baryzentrum eines Zustandes */
						qliste->barryleft = (double)barryLR / (double)number;
					else
						if (qliste->barryright != 0)
							qliste->barryleft = (qliste->barryright + ((double)barryLR / (double)number)) / 2.0;
						else
							qliste->barryleft = (double)barryLR / (double)number;
				else
					qliste->barryleft = 0;
			}
			qliste = qliste->vertsucc;
		}
		BarryIILLevelSort(levl->qlist, levmat, &count);
		/* Sortiert Zustaende einer Ebene nach LR-Baryzentrum (oder MW) und be-*/
		/* stimmt Ueberschneidungen zwischen aktueller und nachfolgender Ebene */
		BarryIIFindLREdgeCrosses(levmat, count, &qcross);
		/* Bestimme Ueberschneidungen */
		*levlist = levl;
		levl = levl->levsucc;
		*cross += qcross;
	}
} /*BarryIILRPass*/



static void BarryIIRLPass(plevel *levlist, int *cross, int *pass)
	/* Bestimme RL-Baryzentrum (Nachfolger) aller Zustaende */
	/* Ueberschneidungen nach Rechts-Links-Schritt */
{
	int barryRL, number, count, qcross;
	pvertex qliste;
	plist qsucc;
	plevel levl;
	matrixlevelarray levmat;

	*cross = 0;
	levl = *levlist;			/* Liste der Ebenen */
	while (levl != NULL) {
		qcross = 0;
		qliste = levl->qlist;	/* Liste der Zustaende einer Ebene */
		while (qliste != NULL) {
			if (qliste->q != -1) {
				number = 0;				/* Anzahl der Vorgaenger */
				barryRL = 0;			/* Summe der Positionen der Vorgaenger */
				qsucc = qliste->suc;	/* Liste der Nachfolger eines Zustandes */
				while (qsucc != NULL) {
					number++;
					barryRL += qsucc->edge->pos;
					qsucc = qsucc->listsucc;
				}
				if (number != 0)
					if (*pass <= 2)		/* LR-Baryzentrum eines Zustandes */
						qliste->barryright = (double)barryRL / (double)number;
					else
						if (qliste->barryleft != 0)
							qliste->barryright = (qliste->barryleft + ((double)barryRL / (double)number)) / 2.0;
					else
						qliste->barryright = (double)barryRL / (double)number;
				else
					qliste->barryright = 0;
			}
			qliste = qliste->vertsucc;
		}
		BarryIIRLevelSort(levl->qlist, levmat, &count);
		/* Sortiert Zustaende einer Ebene nach RL-Baryzentrum (oder MW) und be-*/
		/* stimmt Ueberschneidungen zwischen aktueller und nachfolgender Ebene */
		BarryIIFindRLEdgeCrosses(levmat, count, &qcross);
		/* Bestimme Ueberschneidungen */
		*levlist = levl;
		levl = levl->levprec;
		*cross += qcross;
	}
} /*BarryIIRLPass*/



void Barryalg(plevel levlist)
{
	int i, j, count, pos, crossdist, crossbarry, crossreal;
	double lrorrl;
	pvertex qlist, ql;
	plevel levhelp;
	plist suclist;
	int crossmat[4];
	matrix1array posmat;
	matrixlevelarray levmat;
	boolean Break;

	i = 0;
	Break = FALSE;
	for (j = 1; j <= 3; j++)
		crossmat[j] = 0;
	do {
		crossmat[1] = crossmat[2];
		crossmat[2] = crossmat[3];
		i++;
		lrorrl = (double)i / 2.0;
		if (trunc(lrorrl) < lrorrl) {
			levhelp = levlist;
			BarryIILRPass(&levhelp, &crossmat[3], &i);
		} else
			BarryIIRLPass(&levhelp, &crossmat[3], &i);
		if (crossmat[3] == 0)
			Break = TRUE;
		else
			if (i >= 4) {
				crossdist = crossmat[3] - crossmat[2];
				if (crossdist == 0  ||
					abs(crossdist) == abs(crossmat[1] - crossmat[2])  &&  crossmat[3] < crossmat[2])
					Break = TRUE;
			}
	} while (i < 20  &&  !Break);
	crossbarry = crossmat[3];
	levhelp = levlist;
	while (levhelp != NULL) {
		qlist = levhelp->qlist;
		while (qlist != NULL) {
			if (qlist->q > 0) {
				posmat[qlist->q] = qlist->pos;
				qlist->barryleft = qlist->pos;
			} else {
				count = pos = 0;
				suclist = qlist->suc;
				while (suclist != NULL) {
					count++;
					pos = pos + suclist->edge->pos;
					suclist = suclist->listsucc;
				}
				qlist->barryleft = (double)pos / (double)count;
			}
			qlist = qlist->vertsucc;
		}
		BarryLLevelSort(levhelp->qlist, levmat, &count);
		levhelp = levhelp->levsucc;
	}
	levhelp = levlist;
	i = 0;
	Break = FALSE;
	for (j = 1; j <= 3; j++)
		crossmat[j] = 0;
	do {
		crossmat[1] = crossmat[2];
		crossmat[2] = crossmat[3];
		i++;
		lrorrl = (double)i / 2.0;
		if (trunc(lrorrl) < lrorrl) {
			levhelp = levlist;
			BarryLRPass(&levhelp, &crossmat[3], &crossreal, &i);
		} else
			BarryRLPass(&levhelp, &crossmat[3], &crossreal, &i);
		if (crossmat[3] == 0)
			Break = TRUE;
		else
			if (i >= 4) {
				crossdist = crossmat[3] - crossmat[2];
				if (crossdist == 0  ||
					abs(crossdist) == abs(crossmat[1] - crossmat[2])  &&  (crossmat[3] < crossmat[2]))
					Break = TRUE;
			}
	} while (i < 20  &&  !Break);
	levhelp = levlist;
	if (crossbarry < crossreal) {
		while (levhelp != NULL) {
			count = 0;
			qlist = levhelp->qlist;
			while (qlist != NULL) {
				if (qlist->q > 0)  {
					count++;
					qlist->pos = posmat[qlist->q];
				}
				qlist = qlist->vertsucc;
			}
			levhelp->qnumber = count;
			levhelp = levhelp->levsucc;
		}
	} else {
		while (levhelp != NULL) {
			count = 0;			/* Anzahl der Zustaende der akt. Ebene */
			qlist = levhelp->qlist;
			for (i = 1; i <= levhelp->qnumber; i++)
				levmat[i] = NULL;		/* levmat: Zustaende der akt. Ebene */
			while (qlist != NULL) {
				if (qlist->q != -1) {
					count++;
					levmat[count] = qlist;
				}
				qlist = qlist->vertsucc;
			}
			for (i = 1; i <= count; i++)	/* Sortieren der Zustaende anhand der Positionen */
				for (j = 1; j <= count - i; j++)	/* ohne Dummyebenenknoten (Bubblesort) */
					if (levmat[j + 1]->pos < levmat[j]->pos) {
						ql = levmat[j + 1];
						levmat[j + 1] = levmat[j];
						levmat[j] = ql;
					}
			for (i = 1; i <= count; i++)
				levmat[i]->pos = i;
			levhelp->qnumber = count;
			levhelp = levhelp->levsucc;
		}
	}
} /*Barryalg*/
