/******************************************************************************/
/*  %W% %D% %T%  */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*  Pascal-Programm:     Vera Kell                 Aachen, 31.07.1989         */
/*                                                                            */
/*  ANSI-C  Version:     Raphael M. Grochtmann     Aachen, 31.08.1990         */
/*                                                                            */
/*                                                                            */
/******************************************************************************/



#include <stdio.h>

#include "ext.h"	/* externe Definitionen */



int round(double d)
{
	return (int)(d + 0.55555555);
} /*round*/



int trunc(double d)
{
	return (int)d;
} /*trunc*/



void IntListBeg(pinteger *p, int i)
{
	if ((*p = (pinteger)malloc(sizeof(pint))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in IntListBeg in list.c *** \n");
		exit(1);
	}
	(*p)->pi = i;
	(*p)->psucc = NULL;
} /*IntListBeg*/



void IntListAddEnd(pinteger *pilist, int i)
{
	pinteger p;

	if ((p = (pinteger)malloc(sizeof(pint))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in IntListAddEnd in list.c *** \n");
		exit(1);
	}
	p->pi = i;
	p->psucc = (*pilist)->psucc;
	(*pilist)->psucc = p;
	*pilist = (*pilist)->psucc;
} /*IntListAddEnd*/



void IntListDel(pinteger *pilist)
{
	pinteger phelp;

	while (*pilist != NULL) {
		phelp = *pilist;
		*pilist = (*pilist)->psucc;
		free(phelp);
	}
} /*IntListDel*/



void TransListBeg(ptransition *ptrans, int q1, int q2, char c)
{
	if ((*ptrans = (ptransition)malloc(sizeof(transition))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in TransListBeg in list.c *** \n");
		exit(1);
	}
	(*ptrans)->q1 = q1;
	(*ptrans)->q2 = q2;
	(*ptrans)->tchar = c;
	(*ptrans)->succ = NULL;
} /*TransListBeg*/



void TransListAddEnd(ptransition *translist, int q1, int q2, char c)
{
	ptransition ptrans;

    if ((ptrans = (ptransition)malloc(sizeof(transition))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in TransListAddEnd in list.c *** \n");
		exit(1);
	}
    ptrans->q1 = q1;
    ptrans->q2 = q2;
    ptrans->tchar = c;
	ptrans->succ = (*translist)->succ;
	(*translist)->succ = ptrans;
	(*translist) = (*translist)->succ;
} /*TransListAddEnd*/



void MatListBeg(pmatrix *pm, int i, strg st)
{
	if ((*pm = (pmatrix)malloc(sizeof(pmat))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in MatListBeg in list.c *** \n");
		exit(1);
	}
	(*pm)->pmi = i;
	strcpy((*pm)->pmstrg, st);
	(*pm)->pmsucc = NULL;
} /*MatListBeg*/



void MatListAddEnd(pmatrix *pmlist, int i, strg st)
{
	pmatrix pm;

    if ((pm = (pmatrix)malloc(sizeof(pmat))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in MatListAddEnd in list.c *** \n");
		exit(1);
	}
    pm->pmi = i;
    strcpy(pm->pmstrg,  st);
	pm->pmsucc = (*pmlist)->pmsucc;
	(*pmlist)->pmsucc = pm;
	(*pmlist) = (*pmlist)->pmsucc;
} /*MatListAddEnd*/



void MatListDel(pmatrix *pmlist)
{
	pmatrix pm;

	while (*pmlist != NULL) {
		pm = *pmlist;
		*pmlist = (*pmlist)->pmsucc;
		free(pm);
	}
	*pmlist = NULL;
} /*MatListDel*/



static void PListBeg(plist *p, int edint, strg edst, pvertex vert)
{
	if ((*p = (plist)malloc(sizeof(list))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in PListBeg in list.c *** \n");
		exit(1);
	}
	(*p)->edgeint = edint;
	strcpy((*p)->edgest, edst);
	(*p)->edge = vert;
	(*p)->listsucc = NULL;
} /*PListBeg*/


void PListAddBeg(plist *pplist, int edint, strg edst, pvertex vert)
{
	plist p;

    if ((p = (plist)malloc(sizeof(list))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in PListAddBeg in list.c *** \n");
		exit(1);
	}
    p->edgeint = edint;
    strcpy(p->edgest, edst);
    p->edge = vert;
    p->listsucc = *pplist;
	*pplist = p;
} /*PListAddBeg*/



static void PListAddEnd(plist *pplist, int edint, strg edst, pvertex vert)
{
	plist p;

    if ((p = (plist)malloc(sizeof(list))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in PListAddEnd in list.c *** \n");
		exit(1);
	}
	p->edgeint = edint;
	strcpy(p->edgest, edst);
	p->edge = vert;
	p->listsucc = (*pplist)->listsucc;
	(*pplist)->listsucc = p;
	(*pplist) = (*pplist)->listsucc;
} /*PListAddEnd*/



void PListElemDel(plist *pplist, pvertex vert)
{
	plist pphelp, pppre;
	boolean vertfound;

	vertfound = FALSE;
	if (*pplist != NULL  &&  (*pplist)->edge == vert) {
		pphelp = *pplist;
		*pplist = (*pplist)->listsucc;
		free(pphelp);
		vertfound = TRUE;
	} else {
		if (*pplist != NULL)
			pphelp = (*pplist)->listsucc;
		else
			pphelp = NULL;
		pppre =*pplist;
		while (!vertfound  &&  pphelp != NULL) {
			if (pphelp->edge == vert) {
				pppre->listsucc = pphelp->listsucc;
				free(pphelp);
				pphelp = pppre;
				vertfound = TRUE;
			}
			pppre = pphelp;
			pphelp = pphelp->listsucc;
		}
	}
} /*PListElemDel*/



void PListDel(plist *pplist)
{
	plist phelp;

	while (*pplist != NULL) {
		phelp = *pplist;
		*pplist = (*pplist)->listsucc;
		free(phelp);
	}
} /*PListDel*/



void VertexListBeg(pvertex *vert, int state, int position, double barleft, double barright)
{
	if ((*vert = (pvertex)malloc(sizeof(vertex))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in VertexListBeg in list.c *** \n");
		exit(1);
	}
	(*vert)->q = state;
	(*vert)->pos = position;
	(*vert)->xkoor = 0;
	(*vert)->ykoor = 0;
	(*vert)->barryleft = barleft;
	(*vert)->barryright = barright;
	(*vert)->pre = NULL;
	(*vert)->suc = NULL;
	(*vert)->levl = NULL;
	(*vert)->vertsucc = NULL;
} /*VertexListBeg*/



void VertexListAddEnd(pvertex *vertlist, int state, int position, double barleft, double barright)
{
	pvertex vert;

    if ((vert = (pvertex)malloc(sizeof(vertex))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in VertexListAddEnd in list.c *** \n");
		exit(1);
	}
	vert->q = state;
	vert->pos = position;
	vert->xkoor = 0;
	vert->ykoor = 0;
	vert->barryleft = barleft;
	vert->barryright = barright;
	vert->pre = NULL;
	vert->suc = NULL;
	vert->levl = NULL;
	vert->vertsucc = (*vertlist)->vertsucc;
	(*vertlist)->vertsucc = vert;
	*vertlist = (*vertlist)->vertsucc;
} /*VertexListAddEnd*/



void VertexListElemDel(pvertex *vertlist, int state, int *delnumber)
{
	pvertex verthelp, vertpre;
	plist prelist, suclist, levllist;

	*delnumber = 0;
	while (*vertlist != NULL  &&  (*vertlist)->q == state) {
		verthelp = *vertlist;
		*vertlist = (*vertlist)->vertsucc;
		prelist = verthelp->pre;
		while (prelist != NULL) {
			PListElemDel(&prelist->edge->suc, verthelp);
			prelist = prelist->listsucc;
		}
		PListDel(&verthelp->pre);
		suclist = verthelp->suc;
		while (suclist != NULL) {
			PListElemDel(&suclist->edge->pre, verthelp);
			suclist = suclist->listsucc;
		}
		PListDel(&verthelp->suc);
		levllist = verthelp->levl;
		while (levllist != NULL) {
			PListElemDel(&levllist->edge->levl, verthelp);
			levllist = levllist->listsucc;
		}
		PListDel(&verthelp->levl);
		free(verthelp);
		(*delnumber)++;
	}
	vertpre = *vertlist;
	if (*vertlist != NULL)
		verthelp = (*vertlist)->vertsucc;
	else
		verthelp = *vertlist;
	while (verthelp != NULL) {
		if (verthelp->q == state) {
			vertpre->vertsucc = verthelp->vertsucc;
			prelist = verthelp->pre;
			while (prelist != NULL) {
				PListElemDel(&prelist->edge->suc, verthelp);
				prelist = prelist->listsucc;
			}
			PListDel(&verthelp->pre);
			suclist = verthelp->suc;
			while (suclist != NULL) {
				PListElemDel(&suclist->edge->pre, verthelp);
				suclist = suclist->listsucc;
			}
			PListDel(&verthelp->suc);
			levllist = verthelp->levl;
			while (levllist != NULL) {
				PListElemDel(&levllist->edge->levl, verthelp);
				levllist = levllist->listsucc;
			}
			PListDel(&verthelp->levl);
			free(verthelp);
			(*delnumber)++;
			verthelp = vertpre->vertsucc;
		} else {
			vertpre = verthelp;
			verthelp = verthelp->vertsucc;
		}
	}
} /*VertexListElemDel*/



void VertexListDel(pvertex *vertlist)
{
	pvertex	vert;

	while (*vertlist != NULL) {
		vert = *vertlist;
		*vertlist = (*vertlist)->vertsucc;
		PListDel(&vert->pre);
		PListDel(&vert->suc);
		PListDel(&vert->levl);
		free(vert);
	}
} /*VertexListDel*/



static void VertexListOutput(pvertex vertlist)
{
	plist prelist, suclist, levllist;

	while (vertlist != NULL) {
		printf("   Zust.: %d  ", vertlist->q);
		printf("Pos.: %d  ", vertlist->pos);
		if (vertlist->xkoor != 0  &&  vertlist->ykoor != 0) {
			printf("X-Koord.: %d  ", vertlist->xkoor);
			printf("Y-Koord.: %d\n", vertlist->ykoor);
		}
		if (vertlist->barryleft != 0)
			printf("BaryL: %d  ", vertlist->barryleft);
		if (vertlist->barryright != 0)
			printf("BaryR: %d  ", vertlist->barryright);
		prelist = vertlist->pre;
		if (prelist != NULL)
			printf("Vorg.: ");
		while (prelist != NULL) {
			printf("%d ", prelist->edge->q);
			printf("%d ", prelist->edgeint);
			printf("%s  ", prelist->edgest);
			prelist = prelist->listsucc;
		}
		suclist = vertlist->suc;
		if (suclist != NULL)
			printf("Nachf.: ");
		while (suclist != NULL) {
			printf("%d ", suclist->edge->q);
			printf("%d ", suclist->edgeint);
			printf("%s  ", suclist->edgest);
			suclist = suclist->listsucc;
		}
		levllist = vertlist->levl;
		if (levllist != NULL)
			printf("Eb.: ");
		while (levllist != NULL) {
			printf("%d ", levllist->edge->q);
			printf("%d ", levllist->edgeint);
			printf("%s  ", levllist->edgest);
			levllist = levllist->listsucc;
		}
		printf("\n");
		vertlist = vertlist->vertsucc;
	}
} /*VertexListOutput*/



void AddPreSucVertex(pvertex *prestate, pvertex *actstate)
{
	plist phelp;
	boolean abbruch;
	strg st;

	abbruch = FALSE;
	st[0] = '\0';
	phelp = (*actstate)->pre;
	if (phelp == NULL)
		PListBeg(&(*actstate)->pre, 0, st, *prestate);
	else {
		if (phelp->edge->q == (*prestate)->q  &&  (*prestate)->q != -1)
			abbruch = TRUE;
		else {
			while (phelp->listsucc != NULL) {
				phelp = phelp->listsucc;
				if (phelp->edge->q == (*prestate)->q  &&  (*prestate)->q != -1)
					abbruch = TRUE;
			}
			if (abbruch != TRUE)
				PListAddEnd(&phelp, 0, st, *prestate);
		}
	}
	phelp = (*prestate)->suc;
	if (phelp == NULL)
		PListBeg(&(*prestate)->suc, 0, st, *actstate);
	else {
		if (phelp->edge->q == (*actstate)->q  &&  (*actstate)->q != -1)
			abbruch = TRUE;
		while (phelp->listsucc != NULL) {
			phelp = phelp->listsucc;
			if (phelp->edge->q == (*actstate)->q  &&  (*actstate)->q != -1)
				abbruch = TRUE;
		}
		if (abbruch != TRUE)
			PListAddEnd(&phelp, 0, st, *actstate);
	}

} /*AddPreSucVertex*/



void LevelListBeg(plevel *levl, int lev, int qnr, pvertex qlist)
{
	if ((*levl = (plevel)malloc(sizeof(level))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in LevelListBeg in list.c *** \n");
		exit(1);
	}
	(*levl)->lev = lev;
	(*levl)->qnumber = qnr;
	(*levl)->qlist = qlist;
	(*levl)->levsucc = NULL;
	(*levl)->levprec = NULL;
} /*LevelListBeg*/



void LevelListAddEnd(plevel *levlist, int lev, int qnr, pvertex qlist)
{
	plevel levl;

    if ((levl = (plevel)malloc(sizeof(level))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in LevelListAddEnd in list.c *** \n");
		exit(1);
	}
	levl->lev = lev;
	levl->qnumber = qnr;
	levl->qlist = qlist;
    levl->levprec = *levlist;
    levl->levsucc = (*levlist)->levsucc;
    (*levlist)->levsucc = levl;
    (*levlist) = (*levlist)->levsucc;
} /*LevelListAddEnd*/



void LevelListDel(plevel *levlist)
{
	plevel levhelp;

	while (*levlist != NULL) {
		levhelp = *levlist;
		*levlist = (*levlist)->levsucc;
		VertexListDel(&levhelp->qlist);
		free(levhelp);
	}
} /*LevelListDel*/



void CoverBeg(pcover *covlist, int nr, int free)
{
	int j;

	if ((*covlist = (pcover)malloc(sizeof(cover))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in CoverBeg in list.c *** \n");
		exit(1);
	}
	(*covlist)->covnr = nr;
	(*covlist)->covfree = free;
	for (j=1; j <= NMAX-1; j++)
		(*covlist)->covar[j] = 0;
	(*covlist)->covsucc = NULL;
} /*CoverBeg*/



void CoverAddEnd(pcover *covlist, int nr, int free)
{
	int j;
	pcover p;

    if ((p = (pcover)malloc(sizeof(cover))) == NULL) {
		fprintf(stderr, "*** ERROR: out of memory in CoverAddEnd in list.c *** \n");
		exit(1);
	}
	p->covnr = nr;
	p->covfree = free;
	for (j=1; j <= NMAX-1; j++)
		p->covar[j] = 0;
	p->covsucc = (*covlist)->covsucc;
	(*covlist)->covsucc = p;
	(*covlist) = (*covlist)->covsucc;
} /*CoverAddEnd*/



void CoverDel(pcover *covlist)
{
	pcover covhelp;

	while (*covlist != NULL) {
		covhelp = *covlist;
		*covlist = (*covlist)->covsucc;
		free(covhelp);
	}
} /*CoverDel*/
