/* dir.c 3.0 (KIEL) 11.94 */

#ifdef DOS
#include <dos.h>
#endif

#ifdef UNIX
#include <sys/types.h>
#include <dirent.h>
#endif

#include "ext.h"

/* functions included:
 *	       char  *getref()
 *	static void  drawscreen()
 *	static boole prtentry()
 *	static boole a_select()
 *	       boole showdir()
 */

#define DIRROW 3
#define DIRCOL 2
#define DIRLIN 20
#define DIRLEN (COLS-3)


static char *pattern;
static char directory[PATHLEN];
static int row,col;

#ifdef DOS
typedef struct liststring {string   info;
			   struct liststring *next;
			  }*slist;

#define newslist() (slist)newbuf((posint)1,(posint)sizeof(struct liststring))
#endif
/******************************************************************/
/******************************************************************/
char *
getref(name)
char *name;
/* extract the reference of file name 
 * RETURN: the reference string
 */
{ char fname[PATHLEN+NLEN+5];
  char ref[REFLEN+2];
	(void)strcpy(fname,workdir);
	(void)strcat(fname,name);
	if ((amrp=fopen(fname,"r")) == NULL) {
#ifdef DEBUG
		perror("getref 1");
#endif
		return "CANNOT OPEN FILE!";
	}
	frdin(); frdin(); frdin(); frdin();
	(void)strcpy(ref,line);
	ref[strlen(line)-1] = '\0';

	if (ferror(amrp)) {
		(void)fclose(amrp);
		return "I/O ERROR";
	}
	(void)fclose(amrp);

	return ref;
} /* getref */

/******************************************************************/
static void
drawscreen()
{
	clear(); row = DIRROW+1; col = DIRCOL+2;
	maketitle(TRUE,"C O N T E N T S");
	headbox(DIRROW,DIRCOL,DIRLIN,DIRLEN,directory);
	move(row,col);
} /* drawscreen */

/******************************************************************/
static boole
prtentry(name)
char *name;
/* RETURN: TRUE iff end with <ESC> */
{ char *ldot;
  int r;
  char ch;
	r = row++;
	if (row == DIRLIN) 
           {
            mvaddstr(r,col,"---- MORE ---- (");
            addstr(qtxt); 
            addstr(" to quit listing) ----");
            refresh(); 
            ch = getch();
            if ((ch == qch) || (!isspace(ch))) 
               {
                (void)ungetc(ch,stdin);
                 mvaddstr(r,col,"---- QUIT ----");
                 clrtoeol(); refresh(); 
                 return TRUE; 
               }
            drawscreen();
            r = row++;
	   }
	ldot = (char*)strrchr(name,'.');
	*ldot = '\0'; mvaddstr(r,col,name); *ldot = '.';
	mvaddstr(r,col+10,": "); addstr(getref(name));
	return FALSE;
} /* prtentry */

/******************************************************************/
#ifdef DOS
boole
showdir(pat)
char *pat;
/* shows the files of the directory ending with pat 
 * RETURN: TRUE ok
 *         FALSE: error
 */
{struct find_t amorefile;
 slist firstname,lastname;
 int i,num=0;
 boole quit;

 pattern = pat;
 (void)strcpy(directory,workdir);
 directory[strlen(directory)-1] = '\0';
 (void)strcat(directory,PATHSTR);
 (void)strcat(directory,"*.");
 (void)strcat(directory,pat);
 if(_dos_findfirst(directory,_A_NORMAL,&amorefile)==0)
    {
     i=strlen(amorefile.name)+1;
     firstname=newslist();
     firstname->info=newstring(i);
     (void)strcpy(firstname->info,amorefile.name);
     firstname->next=NULL;
     lastname= firstname;
     num++;
    }
 if(num)
    while(_dos_findnext(&amorefile)==0)
       {
        i=strlen(amorefile.name)+1;
        lastname->next=newslist();
        lastname=lastname->next;
        lastname->next=NULL;
        lastname->info=newstring(i);
        (void)strcpy(lastname->info,amorefile.name);
	num++;
       }
 else
   return FALSE;
 drawscreen();
for(quit = FALSE , i = 0; (i< num)&&(!quit); i++)
   { quit = prtentry(firstname->info);
     firstname=firstname->next;
   }
if(!quit)refresh();
freebuf();
return TRUE;
} /* showdir */
#endif
/******************************************************************/
#ifdef UNIX
static boole a_select(name)
char *name;
{ char *ldot;                     
    ldot = (char*)strrchr(name,'.');
    if (!ldot || strcmp(++ldot,pattern)) return FALSE;
    else return TRUE;
} /* a_select */
#endif
/*****************************************************************/
#ifdef UNIX
boole showdir(pat)
char *pat;
/* shows the files of the directory ending with pat 
 * RETURN: TRUE ok
 *         FALSE: error
 */
{ 
  boole end;
  char *name;
  DIR *curdir;
  struct dirent *entry;

	pattern = pat;
	(void)strcpy(directory,workdir);
	directory[strlen(directory)-1] = '\0';
        curdir = opendir(directory); 
	if (curdir == NULL) {
#ifdef DEBUG
		perror("showdir 1");
#endif
		return FALSE;
	}
	drawscreen();
        end=FALSE;
        while(!end)
           {
            entry=readdir(curdir);
            if(entry!=NULL)
                { 
                 name=entry->d_name;
                 if(a_select(name)) 
                     end=prtentry(name);
                }
            else
                 end=TRUE; 
            }
        (void)closedir(curdir);
	return TRUE;
} /* showdir */
#endif
