/* eddcl.c 3.0 (KIEL) 11.94 */

#include "ext.h"

/* functions included:
 *	static void howtouse()
 *	static void displayline() 
 *	static void displaykernel()
 *	static void displayimage()
 *             void initarray()
 *             array cpt_image_kernel
 *             int  compsizeofstates()
 *	       int  imsizecompute()
 *             boole dcomp()
 *	static void overview()
 *	static void outdc()
 *	static void printnewbegin()
 *	static void changebegin()
 *	static void primoutdstruct()
 *	       void editdcl()
 */

/******************************************************************/
/* static variables for the output of dclasses */
static monoid stamon;
static int boxsize;
static int immaxsize;
static int row;
static int begincol;
static posint rstart=0,lstart=0,hstart=0,rmax,lmax,hmax;
static posint dstart,dend ; /* first,last dclass in output */
static boole  full; /* full iff all dclasses on screen can be shown full */
static boole  image;
static int  uslines;    /* lines used for output */

static array imarray,kerarray,countarray,countkernel; 
static posint actrang;         /* rang of actual dclass */
/******************************************************************/
/******************************************************************/
/******************************************************************/
/*  first col 0          last col COLS-1
 *  first row 0          last row LINES-1
 * 
 *    if  (boxsize+begincol)<COLS: output with image
 *
 * with image
 *           boxsize  =  max { length of word+3 , length of image+1 } 
 *
 *           image       image 
 *            of          of
 *           lstart      lstart+lmax-1
 *          ------------------
 *kernel    |word  |...  |word| if rmax=0 only a part of one rclass: 
 * of       |word  |...  |word|           words hstart .. hstart+hmax-1
 *rstart    |word  |...  |word|
 *          ------------------
 *          |...   |...  |... |
 *          |...   |...  |... |
 *          ------------------
 *kernel of |word  |...  |word|
 * rstart   |word  |...  |word|
 * +rmax-1  |word  |...  |word| 
 *          ------------------
 *          |      starts at begincol = size of a kernel + 2
 *          image  starts at begincol + 1
 *          kernel starts at STARTKERNEL = 2
 *
 ******************************************************************************
 *
 * without image
 *           boxsize  max length of word + 3
 *
 *          ------------------
 *          |word  |...  |word| if only one rclass: words hstart .. hstart+hmax-1
 *          |word  |...  |word|
 *          |word  |...  |word|
 *          ------------------
 *          |...   |...  |... |
 *          |...   |...  |... |
 *          ------------------
 *          |word  |...  |word|
 *          |word  |...  |word|
 *          |word  |...  |word| 
 *          ------------------
 *          |      starts at begincol = 2 
 *            
 * boxsize, begincol are the same for all dclasses on screen
 * boxsize, begincol are set in changebegin
 *
 * size in rows of a dclass dc: dc->rno*(dc->hsize+1) + 4
 *  ( +4 one free line above + information + image + one line --- )
 * size in cols of a dclass dc->lno*boxsize+begincol + 1
 */

#define STARTKERNEL     2


/******************************************************************/
static void howtouse()
{
 cleartut();
 mvaddstr(LASTROW,LRCOL,"h:left, j:down, k:up, l:right,        q:quit");
 mvaddstr(LASTROW+1,LRCOL,"n,p: next,previous dclass(es),        s: show structure");
 mvaddstr(LASTROW+2,LRCOL,"'*' marks idempotent elements "); 
 refresh();
}

/******************************************************************/
static void displayline() 
/* show one line - in row from columne begincol 
 * with length boxsize*lmax
 */
{
 posint i;
 move(row,begincol);
 for(i=0;i<=boxsize*lmax;i++)
   addch('-');
}

/******************************************************************/
void initarray(mon)
monoid mon;
{
 imarray=newarray(mon->qno+1);
 kerarray=newarray(2*(mon->qno+1));
 countarray=newarray(mon->qno+1);
 countkernel=newarray(mon->qno+1);
}
/******************************************************************/
array cpt_image_kernel(mon,no,flag)
 /* cpt_image computes the image and the kernel
  * the results are stored in imarray and kerarray
  */
monoid mon;
posint no;
boole flag; /* if flag compute image */
{ posint rang=0;
  posint j,i;
  array a=mon->no2trans[no];
  
  for(j=0;j<=mon->qno;j++) 
     if(!countarray[a[j]]++)rang++;
/* countarray[j]==k iff state j is the image of k states */
  if(flag)
   {rang=0;
    for(j=0;j<=mon->qno;j++)
      if(countarray[j]!=0)
         {
          imarray[rang++]=j;
          countarray[j]=0;
         }
    return(imarray);
  }
/* 
 * compute kernel
 * the sets of a kernel are separated by the number mon->qno+1
 * the sets of a kernel are ordered with respect to the least element
 * the representation of a kernel requires an array of length 
 * number of states + rang
 */
 else 
    {
     i=rang+mon->qno+1; /* abbreviation */
     for(j=0;j<i;j++) kerarray[j]=mon->qno+1;
     rang=0;
     for(j=0;j<=mon->qno;j++)
       {
        i=countarray[a[j]]; /* abbreviation */
        if (i!=0)
          /* j is the least state with this image
	   * the states with this image start at position  countkernel[n]
	   */
           {
            kerarray[rang]=j;
	    countkernel[a[j]]=rang+1;
	    rang+=(i+1);
	    countarray[a[j]]=0;
           }
         else
           /* countkernel[a[j]] is already computed */
           {
            kerarray[countkernel[a[j]]]=j;
	    countkernel[a[j]]++;
           }
       } /* end for */
   return(kerarray);
  }
}

/******************************************************************/
static void displaykernel(no)
posint no;
{posint l;
 array k=cpt_image_kernel(stamon,no,FALSE);
 move(row,STARTKERNEL);
 for(l=0;l<actrang+stamon->qno;l++)
	if(k[l]==(stamon->qno+1)) addch('/');
	else {addch(' '); addstr(pi2a(k[l]));}
}

/******************************************************************/
static void displayimage(no,c)
posint no;
int c;
{posint l;
 array i=cpt_image_kernel(stamon,no,TRUE);
 move(row,c);
 for(l=0;l<actrang;l++)
    {addch(' ');
     addstr(pi2a(i[l]));
    }
}

/******************************************************************/
int computesizeofstates(states)
posint states;
/* compute length of string 0 1 2 .. states */
{
 int help=9; /* help = 9,99, .. */
 int size;
 size=(states+1)*2; 
 while(states>help)
  {
   size += states-help;
   help *= 10;
   help +=  9;
  }
 return(size);
}

/******************************************************************/
int imsizecompute(mon,rang)
posint rang;
monoid mon;
/* compute maximal size of an image of rank rang */
{
 immaxsize=computesizeofstates(mon->qno);
 if(rang==(mon->qno+1))return(immaxsize); /* maximal rank */
 return(immaxsize-computesizeofstates(mon->qno-rang));
}

/******************************************************************/
static void overview()
/* print information on the dclasses on screen */
{
 maketitle(TRUE,"D - C L A S S   S T R U C T U R E");
 if(full)
     {
      if(dstart==dend) /* one dclass */
        { mvaddstr(INFOROW,5,"D-Class: "); addstr(pi2a(dstart+1)); }
      else
        { mvaddstr(INFOROW,5,"D-Classes: ");
          addstr(pi2a(dstart+1)); addstr(". - "); addstr(pi2a(dend+1));
        }
      addstr(". of "); addstr(pi2a(stamon->ds->dno));
     }    
  else /* only one dclass */ 
     {
      mvaddstr(INFOROW,5,"D-Class: ");
      addstr(pi2a(dstart+1)); addstr(". of "); addstr(pi2a(stamon->ds->dno));
      move(INFOROW,33);
      if(lmax<=1)
        {addstr("L-Class: ");addstr(pi2a(lstart+1));}
      else
        {addstr("L-Classes: ");addstr(pi2a(lstart+1));addstr(". - ");
         addstr(pi2a(lstart+lmax)); 
        }
      addstr(". of "); addstr(pi2a(stamon->ds->dclassarray[dstart]->lno)); 
      move(INFOROW+1,5);
      if( rmax<=1)
       { addstr("R-Class: ");addstr(pi2a(rstart+1));}
      else
       { addstr("R-Classes: ");addstr(pi2a(rstart+1));addstr(". - ");
         addstr(pi2a(rstart+rmax)); }
      addstr(". of "); addstr(pi2a(stamon->ds->dclassarray[dstart]->rno));  
      move(INFOROW+1,33);
      if(hmax!=stamon->ds->dclassarray[dstart]->hsize)
        {
         addstr("Hclass-Elements: ");
         addstr(pi2a(hstart+1));addstr(". - ");addstr(pi2a(hstart+hmax));
         addstr(". of ");addstr(pi2a(stamon->ds->dclassarray[dstart]->hsize));
        }
      move(INFOROW+2,5);
      if(stamon->ds->dclassarray[dstart]->regular) addstr("D-Class is regular ");
      else  addstr("D-Class is irregular ");
     }
}

/******************************************************************/
static void outdc(dc)
/* rstart rclass in upper row
 * lstart lclass at left side
 * hstart upper element of rclass rstart in upper row
 * row  start of print
 */
d_class dc;
{
 posint rcount;
 posint lno,rno,hno;
 posint help,help1;
 int col;	
 actrang=dc->rang;
 if(!full){clear();overview();}
 row++; /* skip one line */
 if(image) /* output with image and kernel */
  {
   col = begincol+1; /* first usable column */
   for(lno=lstart;lno<lmax+lstart;col+=boxsize)
     displayimage(mult(stamon,dc->org,dc->lrep[lno++]),col);
  }
 else
  {
   move(row,1);
   addstr("D-Class of rank ");
   addstr(pi2a(dc->rang));
  }
 row++;
 displayline();
 row++;
/* print dclass */
 rcount=(rmax)? rmax : 1; 
 for(rno=rstart;rno<rstart+rcount;rno++) 
  /* print rclasses rstart .. rstart+rcount-1 */
       {
        if(image)displaykernel(mult(stamon,dc->rrep[rno],dc->org));
        for(hno=hstart;hno<hstart+hmax;hno++,row++)
           {
            help=mult(stamon,dc->rrep[rno],dc->hclass[hno]);
            col=begincol;
            for(lno=lstart;lno<lstart+lmax;lno++,col+=boxsize)
              {
               mvaddch(row,col,'|');
               help1=mult(stamon,help,dc->lrep[lno]);
               addstr(prword(help1,stamon,TRUE));
              }
              mvaddch(row,col,'|');
           }
        displayline();
        row++;
       }
}
 
/******************************************************************/
static void printnewbegin()
{posint drun;
 d_class dc;
 hstart=0;lstart=0;rstart=0;
 row=STARTROW;
 if(!full)
   {
    dc=stamon->ds->dclassarray[dstart];
    lmax= (COLS-(1+begincol))/boxsize;
    lmax=(lmax>dc->lno)? dc->lno : lmax;
    hmax=((uslines-4)>=dc->hsize)? dc->hsize: uslines-4;
    rmax=(uslines-4)/(dc->hsize+1);
    rmax=(rmax>dc->rno)? dc->rno : rmax;
    outdc(dc);
   }
 else
  /* print all dclass dstart .. dend */
  {
   clear();
   overview();
   for(drun=dstart;drun<=dend;drun++)
   {
    dc=stamon->ds->dclassarray[drun];
    lmax=dc->lno;
    rmax=dc->rno;
    hmax=dc->hsize;
    outdc(dc);
   }
  }
}

/******************************************************************/
static void changebegin(flag)
/* change the first dclass in output 
 * go up iff flag 
 */
boole flag;
{d_class dc;
 boole test; 
 posint dcsize;
 int imsize;
 posint remain=uslines; /* free rows */
 posint nboxsize;
 posint maxlno; /* maximal number of lclasses */ 
 /* compute first dclass */
 if(flag)
   if(dend<(stamon->ds->dno-1))
     { dend++; dstart=dend;}
   else return;
 else
   if(dstart)
     { dstart--; dend=dstart;}
   else return;
  dc=stamon->ds->dclassarray[dend]; /* abbreviation */
  /*
   * test first dclass
   * imsize is  maximal for the first dclass
   * compute image, begincol, boxsize 
   */
  imsize=imsizecompute(stamon,dc->rang); /* rang of the first dclass is maximal */
  begincol=STARTKERNEL + immaxsize + dc->rang - 1; /* size of kernel + STARTKERNEL */
  boxsize=((dc->maxlen+2)>imsize)? dc->maxlen+3 : imsize+1;
  image=((begincol+boxsize)<COLS);
  if(!image)
      {boxsize=dc->maxlen+3;begincol=2;}
  dcsize=(dc->hsize+1)*dc->rno+4;
  if(remain>=dcsize) 
    /* length of dclass < length of page */
   {
     maxlno=dc->lno;
     if((begincol+1+(maxlno*boxsize))>=COLS)
       {full=FALSE;test=FALSE;}
      else
       {full=TRUE;test=TRUE;remain-=dcsize;}
   }
   else
     {test=FALSE;full=FALSE;}
   while(test&&((dend+1)!=stamon->ds->dno))
    /* print dclasses until one d_class can't be printed full */
       {
	dend++;
        dc=stamon->ds->dclassarray[dend];
        nboxsize=dc->maxlen+3;
        nboxsize=(nboxsize>boxsize)? nboxsize : boxsize ;
        maxlno=(dc->lno > maxlno)? dc->lno : maxlno ;
        if((begincol+(maxlno*nboxsize))<COLS)
          {
           dcsize=(dc->hsize+1)*dc->rno+4;
           if(remain>=dcsize)
             { boxsize=nboxsize; remain-=dcsize; }
           else
             { dend--; test=FALSE; }
          }
        else
         { dend--; test=FALSE; }
       }
    printnewbegin();
}

/******************************************************************/
boole dcomp(mon,dc1,dc2)
posint dc1,dc2;
monoid mon;
{
 d_class d1,d2;
 d1=mon->ds->dclassarray[dc1];
 d2=mon->ds->dclassarray[dc2];
 if(d1->rang!=d2->rang)return(FALSE);
 if(d1->regular&&(!d2->regular))return(FALSE);
 if(d2->regular&&(!d1->regular))return(FALSE);
 if(d1->rno!=d2->rno)return(FALSE);
 if(d1->lno!=d2->lno)return(FALSE);
 if(d1->hsize!=d2->hsize)return(FALSE);
 return(TRUE);
}
/******************************************************************/
static void primoutdstruct()
{
 darray d=stamon->ds->dclassarray; /* abbreviation */
 posint drun,dno;
 int colco, count = 5;
 clear();
 drun=0;
 while(drun!=stamon->ds->dno)
    {
     dno=drun+1;
     while((dno<stamon->ds->dno)&&dcomp(stamon,dno,drun))dno++;
      colco=1; mvaddstr(count,colco,pi2a(dno-drun)); 
      colco += 3;
      if(d[drun]->regular) mvaddstr(count,colco,"reg.   ");
      else mvaddstr(count,colco,"irreg. ");
      if((dno-drun)>1) addstr("D-classes rank ");
      else addstr("D-class   rank ");
      addstr(pi2a(d[drun]->rang));
      colco += 24; mvaddstr(count,colco," : ");
      colco += 8;  mvaddstr(count,colco,pi2a(d[drun]->rno));
      colco += 11; mvaddstr(count,colco,pi2a(d[drun]->lno));
      colco += 15; mvaddstr(count,colco,pi2a(d[drun]->hsize));
      drun=dno;
      if(count==(LASTROW-3))
        {
 	 mvaddstr(3,32,"R-classes  L-classes  Elements per H-class");
         mvaddstr(1,5,"G L O B A L  S T R U C T U R E  O F  G R E E N ' S  R E L A T I O N S");
         mvaddstr(count+3,10," Press any key to continue ");
	 refresh();(void)getch();clear();count=5;}
      else 
        count++;
     }
 /* restore old screen */
 mvaddstr(3,32,"R-classes  L-classes  Elements per H-class");
 mvaddstr(1,5,"G L O B A L  S T R U C T U R E  O F  G R E E N ' S  R E L A T I O N S");
 mvaddstr(count+3,10," End global stucture: press any key to continue");
 refresh(); (void)getch(); clear();
}

/******************************************************************/
/******************************************************************/
void editdcl(mon)
/* moves in editdcl    are: h show one more l-class on the left side
 *                          l                              rigth side
 *                          j               r-class on the lower side
 *                          k               r-class        upper side
 *                          n show next d-class
 *                          p show previous d-class
 *                          s show structure
 */
/* if !full some information on the top of the side:
 *    dno      lno    (ir)regular
 *    rno      hsize
 */
monoid mon;
{
 d_class dc;
 int letterlength;
 uslines=LASTROW-STARTROW-1;
 stamon=mon;
 /* test: words longer then screen */
 letterlength=(stamon->sno<=ALPHSIZE)? 1 : (1+strlen(pi2a(stamon->sno)));
 if((stamon->no2length[stamon->mno-1]*letterlength+3)>COLS)
    {primoutdstruct();return;}
 /* normal output */
 initarray(stamon);
 immaxsize=computesizeofstates(stamon->qno);
 dstart=1;
 changebegin(FALSE);
 dc=stamon->ds->dclassarray[dstart];
 /* output first dclass */
 for(;;)
   {
    howtouse();
    switch(getch())
       {
        case 's': /* show the structure of the monoid */
        case 'S': primoutdstruct();
                  /* construct normal display */ 
                  printnewbegin();
                  break;

        case 'h': /* move page left */
        case 'H': if((lstart)&&(!full))
                    {
                     lstart-=(lstart>=lmax)? lmax : lstart;
                     row=STARTROW;
                     outdc(dc);
                    }
                  break; 
        case 'l': /* move page right */
        case 'L': if(((lstart+lmax)<dc->lno)&&(!full))
                    {
                     lstart=(lstart+2*lmax-1<dc->lno)? lstart+lmax : dc->lno-lmax;
                     row=STARTROW;
                     outdc(dc);
                    }
                  break;
        case 'j': /* move page down */
        case 'J': if(!full)
                    {if(dc->hsize>LINES-12)/* only one rclass */
                       if(hstart+hmax==dc->hsize)/* next r-class */
                         {if(rstart+1<dc->rno) 
                             {rstart++;hstart=0;row=STARTROW;outdc(dc);}
                         }
                       else  /* same r-class */
                         {hstart=(hstart+2*hmax<dc->hsize-1)? hstart+hmax : dc->hsize-hmax;
                          row=STARTROW;outdc(dc);
                         }
                     else
                       if(rstart+rmax<dc->rno)
                         {rstart=(rstart+2*rmax-1<dc->rno)? rstart+rmax : dc->rno-rmax;
                          row=STARTROW;outdc(dc);
                         }
                     }
                   break;
        case 'k': /* move page up */
        case 'K':if(!full)
                    if(dc->hsize>LINES-12) 
                     if(!hstart)
                        /* previous r-class */
                        if(rstart) 
                           {
                            rstart--;
                            row=STARTROW;
                            outdc(dc);
                           }
                        else;
                     else 
                        /* same r-class */
                       {
                        hstart=(hstart>=hmax)? hstart-hmax : 0 ;
                        row=STARTROW;
                        outdc(dc);
                       }
                   else
                     if(rstart)
                       {
                        rstart=(rstart>=rmax)? rstart-rmax : 0 ;
                        row=STARTROW;
                        outdc(dc);
                       }
                   break;

        case 'n': /* advance some dclasses */
        case 'N': changebegin(TRUE);
                  dc=stamon->ds->dclassarray[dstart];
                  break;
        case 'p': /* go one dclass back */
        case 'P': changebegin(FALSE);
                  dc=stamon->ds->dclassarray[dstart];
                  break;
        case 'q': /* quit */
	case 'Q': clear();
                  freebuf(); 
                  return;
        default:  /* do nothing */ ;
      } /* end switch */
    } /* end forever */
}
