/* edrex.c 3.0 (KIEL) 11.94 */

#include "ext.h"

/* functions included
 *	       string pitos()
 *	static EXPRESS tree2string()
 *	static void tutor()
 *	static void builddef()
 *      static void scrolldef()
 *	static void buildscr()
 *	static void write_expr()
 *  	static void chknextline()
 *	static void chkprevline()
 *	static void inloop()
 *	static void predef()
 *	static void enddef()
 *	static void definput()
 *	static void defal()
 *	static void saverex()
 *	static strstack gluelines() 
 *	static void makelines()
 *	static void initab()
 *	static void initrex()
 *	static void preinput()
 *	static char initre()
 *      static void init_index()
 *	static EDIT_RESULT editor()
 *		void edrex()
 */
#define FIRSTCOL	5
#define INFOROW		3
#define FIRSTROW	(BOXEROW+3)
#define MAXCHAR		255
/******************************************************************/

typedef struct abb {			/* an abbreviation */
		strstack info;
		posint length;		/* length of all parts */
	} *abbrev;
typedef struct str_edit_parms {
               regex       rex;
               posint      firstcol, firstrow, lastrow;
               PARSE_INPUT parse_parms;
               boole       def, edit;
        } * EDIT_PARMS;
                
typedef struct str_edit_res {
               t_elem tree;
               char nextkey;
        } *EDIT_RESULT;

typedef struct str_state_of_editor {
               strstack bottom, top, actline;
               posint scrrow, scrcol, actpos;
        } *STATE_OF_EDITOR;

typedef struct str_express {
               string expr;
               posint length;
        } *EXPRESS;

/******************************************************************/
static int scrrow,scrcol,defrow; /* screen positions */
static posint actpos,		 /* counter for one row (actline) */
              maxlet;		 /* number of letters */

	     

static int linelength = 0;
static string error_message;

#define newpart(A)	{ A = (strstack)newbuf(1,sizeof(struct part)); \
			  A->info = (char *)newbuf((posint)(linelength+1),sizeof(char));\
			  A->info[linelength] = '\0'; A->lastpos = 0;}
#define newab(A)	{ ablist[A] = (abbrev)newbuf(1,sizeof(struct abb));\
			  newpart(ablist[A]->info);}
#define stdaction	{ addch(ch); scrcol++;refresh();\
			  actline->info[actpos++] = ch;\
			  ++(actline->lastpos);}

static char maxdef,	/* last char for defs; save for ch */
            FirstDef;
static abbrev ablist[NABBR+1];	/* array of the abbreviations (defs) */

/* lines are mangaged as a list */  
static strstack bottom,top,actline,freest = NULL, FirstLine;

/* Abbreviations in postfixnotation */
EXPRESS *AbbsInPostfix;

/* the two modes: command, input */
#define COMMA 0
#define INPUT 1

#define NORMAL      1 
#define DEFINP      0
#define NOEDIT      2

#define new_parse_input() ((PARSE_INPUT) newbuf(1, sizeof(struct str_parse_input)))

#define new_array(N) ((array) newbuf(N, sizeof(posint)))

#define new_strar(N) ((arrayofstring) newbuf(N, sizeof(string)))

#define new_string(N) ((string) newbuf(N, sizeof(char)))

#define new_edit_res() ((EDIT_RESULT)  newbuf(1, sizeof(struct str_edit_res)))

#define new_edit_parms() ((EDIT_PARMS)  newbuf(1, sizeof(struct str_edit_parms)))

#define new_editor_state() ((STATE_OF_EDITOR) newbuf(1, sizeof(struct str_state_of_editor)))

#define new_strstack() ((strstack) newbuf(1, sizeof(struct part)))
/******************************************************************/

/* Converts a posint n to a string */
/* No further comments */

string pitos(n)
posint n;
{
   posint i = n,
          count = 1;
   string outstring;

   while (i > 9) { ++count; i /= 10; };
   outstring = new_string(count + 1);
   i = n;
   while (count > 0)
   {
      outstring[count - 1] = (char) ('0' + (i % 10));
      i /= 10;
      --count;
   }
   return outstring;
}
/******************************************************************/
static EXPRESS tree2string(Root)
t_elem Root;
{
   string OutString;
   t_elem Node = Root;
   posint Count = 0, Length = 0;
   char FirstLet;
   EXPRESS RetVal = (EXPRESS) newbuf(1, sizeof(struct str_express)); 

   while (Node->sons_no != 0) Node = Node->son[0];

   while (Node != NULL)
   {
      FirstLet = Node->expr[0]; 
      switch (Node->sons_no)
      {
         case 0:  if ((FirstLet >= 'A') && (FirstLet <= MAXLET))
                    Length += AbbsInPostfix[FirstLet - 'A']->length;
                  else 
                    Length += strlen(Node->expr);
                  Node = Node->father;
                  break;

         case 1:  switch (FirstLet)
                  {
                     case leftbrch: break;
                     default:  ++Length; break;
                  }
                  Node = Node->father;
                  break;
         case 2:  switch (Node->son_passed)
                  {
                     case 0:  Node->son_passed = 1;
                              Node = Node->son[1];
                              while (Node->sons_no != 0) Node = Node->son[0];                                 break;
                     case 1:  Node->son_passed = 0;
                              ++Length;
                              Node = Node->father;
                              break;
                     default: ;
                  }
                  break;
         default:;
      }
   }
   Node = Root;
   OutString = new_string(Length + 1);

   RetVal->length = Length;

   while (Node->sons_no != 0) Node = Node->son[0];

   while (Node != NULL)
   {
      FirstLet = Node->expr[0];
      switch (Node->sons_no)
      {
         case 0:  if ((FirstLet >= 'A') && (FirstLet <= MAXLET))
                  {
                    strcpy(&OutString[Count], AbbsInPostfix[FirstLet - 'A']->expr);
                    Count += AbbsInPostfix[FirstLet - 'A']->length;
                  }
                  else 
                  { 
                    strcpy(&OutString[Count], Node->expr);
                    Count += strlen(Node->expr);
                  }
                  Node = Node->father;
                  break;

         case 1:  switch (FirstLet)
                  {
                     case leftbrch: break;                             
                     default:  OutString[Count++] = FirstLet; 
                               break;
                  }
                  Node = Node->father;
                  break;
         case 2:  switch (Node->son_passed)
                  {
                     case 0:  Node->son_passed = 1;
                              Node = Node->son[1];
                              while (Node->sons_no != 0) Node = Node->son[0];                                                      break;
                     case 1:  Node->son_passed = 0;
                              OutString[Count++] = FirstLet;
                              Node = Node->father;
                              break;
                     default: ;
                  }
                  break;
         default:;
      }
   }
   RetVal->expr = OutString;
  
   return RetVal;
}
/******************************************************************/
static void tutor(mode, InpMode)
boolx mode, InpMode;
/* the text for the allowed commands on the tutor lines */
{ 	
	switch(mode) {
	case COMMA: mvaddstr(LASTROW+1,LRCOL,"h: left, j: down, k: up, l: right  q: quit"); clrtoeol();
		    switch (InpMode)
                    {
                      case NORMAL : mvaddstr(LASTROW+2,LRCOL, "i: insert mode  s: scroll definitions  d: define"); break;
                      case NOEDIT : mvaddstr(LASTROW+2,LRCOL, "                s: scroll definitions"); break;
                      case DEFINP : mvaddstr(LASTROW+2,LRCOL, "i: insert mode");break;

                      default     : /* Should not happen */;
                    }
                    clrtoeol();
                    break;
        case INPUT :move(LASTROW,LRCOL); clrtoeol();
		    mvaddstr(LASTROW+1,LRCOL,"Meaning: ");
		    addch(epsch); addstr(" empty word, ");
		    addch(langch); addstr(" = {}, ");
		    addch(unionch); addstr(" union, ");
		    addch(concatch); addstr(" concat, ");
		    addch(starch); addstr(" star, ");
		    addch(plusch); addstr(" plus");
		    addstr(", ");
		    addch(minusch); addstr(" minus");
                    clrtoeol();
		    move(LASTROW+2,LRCOL);
		    addch(complch); addstr(" complement, ");
		    addch(insecch); addstr(" intersection; ");
		    addstr("<BACKSPACE>: delete left  ");
		    addstr(qtxt);addstr(": quit"); 
                    clrtoeol();
		    
	}
	move(scrrow,scrcol); refresh();
} /* tutor */

/******************************************************************/
#define BOXSROW	INFOROW+2
#define BOXEROW INFOROW+12
#define DEFCOL  FIRSTCOL + 5
#define DEFECOL linelength - 2
#define DEFLENGTH DEFECOL-DEFCOL

static void builddef(s)
char s; /* max. letter in definition */
/* draws and fills the "definition" box */
{ char i;
  int idx = 0;
  strstack plist;
	for(i=BOXSROW;i<=BOXEROW; i++) { move(i,0); clrtoeol(); }
	(void)headbox(BOXSROW,FIRSTCOL,BOXSROW,DEFECOL,"D E F I N I T I O N S");

	defrow = BOXSROW+1;
	for(i=s; i <= maxdef; i++) {
		mvaddch(defrow, DEFCOL-3, i);
                addstr(": ");
		idx = i - 'A';
		plist = ablist[idx]->info;
		while ((defrow < BOXEROW) && (plist != NULL)) {
			addstr(plist->info); defrow++;
			plist = plist->next;
			move(defrow,DEFCOL);
		}
		if (defrow == BOXEROW) break;
	}
	if (plist != NULL) { mvaddch(defrow,DEFCOL-3,i); addstr("> ");}
	(void)headbox(BOXEROW+1,FIRSTCOL,BOXEROW+1,DEFECOL,"E X P R E S S I O N");
	/* return to expression-screen */

        FirstDef = 'A';
        FirstLine = ablist[0]->info;

	move(scrrow,scrcol); refresh();
} /* builddef */
/******************************************************************/
static void scrolldef()
{ char i;
  int idx = 0;
  strstack PList, FLine;

  for(i = BOXSROW + 1; i <= BOXEROW; i++) { move(i,0); clrtoeol(); }
  defrow = BOXSROW + 1;
  FirstLine = FirstLine->next;
  if (FirstLine == NULL)
  { 
    FirstDef = (FirstDef == maxdef) ? 'A' : FirstDef + 1;
    FirstLine = ablist[FirstDef - 'A']->info;
  } 
  FLine = FirstLine;
  for(i=FirstDef; ; i++) 
  {
    idx = i - 'A';
    mvaddch(defrow, DEFCOL-3, i);
    if (FLine == ablist[idx]->info) addstr(": ");
    else addstr("> ");
    PList = FLine;
    while ((defrow < BOXEROW) && (PList != NULL)) 
    {
      addstr(PList->info);
      defrow++;
      PList = PList->next;
      move(defrow,DEFCOL);
    }
    if ((i == maxdef) || (defrow == BOXEROW)) break;
    FLine = ablist[idx + 1]->info;
  }
  if (PList != NULL) { mvaddch(BOXEROW,DEFCOL-3,i); addstr("> ");}

  /* return to expression-screen */
  move(scrrow,scrcol);
 
  refresh();
  return;
} /* scrolldef */

/******************************************************************/
static void buildscr(s)
posint s; /* size of alphabet */
/* builds the screen (without the "definition"box) */
{ strstack plist;
  int row,col;
	maketitle(TRUE,"G E N E R A L I Z E D    R E G U L A R   E X P R E S S I O N");
	mvaddstr(INFOROW,FIRSTCOL,"Size of alphabet: ");
	addstr(pi2a(s));
	
	row = FIRSTROW; col = FIRSTCOL;
	if (actline->prev != NULL) plist = actline->prev;
	else plist = actline;
	while ((row < LASTROW) && (plist != NULL)) {
		move(row,col); clrtoeol();
		addstr(plist->info);
		row++;
		plist = plist->next;
	}
	while(row < LASTROW) {
		move(row,col); clrtoeol();
		row++;
	}
	move(scrrow,scrcol); refresh();
} /* buildscr */
/******************************************************************/
static void write_expr(FirstCol, FirstRow, LastRow, Bottom, ActLine)
posint FirstCol, FirstRow, LastRow;
strstack Bottom, ActLine;
{ strstack PList = Bottom;
  posint Row, Col, Count = 0;
  

  Row = FirstRow; 
  Col = FirstCol;
  while  (PList != ActLine) { PList = PList->next; ++Count; }
  PList = Bottom;
  if ((FirstRow  + Count) >= LastRow)
  {
    Count = (FirstRow + Count) - LastRow + 1;
    while (Count > 0) { PList = PList->next; --Count; }
    scrrow = LastRow - 1;
  } 
  else scrrow = FirstRow + Count;
  while ((Row < LastRow) && (PList != NULL)) 
  {
    move(Row, Col); 
    clrtoeol();
    addstr(PList->info);
    Row++;
    PList = PList->next;
  }
  while(Row <= LastRow) 
  {
    move(Row, Col); 
    clrtoeol();
    Row++;
  }
  move(scrrow,scrcol); 
  refresh();

  return;
} /* write_expr */
 
/******************************************************************/
static void chknextline(ll,FirstCol,FirstRow, LastRow)
int ll;  /* linelength, firstcol */
posint FirstCol, FirstRow, LastRow;
/* checks for linebreak */
{ strstack hlp;
	if (scrcol >= ll-4) {
		actline->lastpos = actpos-1;
                newpart(hlp);
		hlp->next = actline->next;
		hlp->prev = actline;
		actline->next = hlp;
		actline = hlp;
		if (actline->next != NULL) 
			actline->next->prev = actline;
		else top = actline;
		scrcol = FirstCol; scrrow++;
                write_expr(FirstCol, FirstRow, LastRow, bottom, actline);	
		move(scrrow, scrcol);
                refresh();
                actpos = 0;

	}
} /* chknextline */

/******************************************************************/
static void chkprevline(FirstCol, FirstRow, LastRow)
posint FirstCol, FirstRow, LastRow;
/* checks for linebreak when using the <BACKSPACE> */
{  
   if ((scrcol == FirstCol) && (actline->lastpos == 0)) 
   {
      if (bottom == top) return;
      if (actline == bottom) 
      { 
        bottom = (actline = actline->next);
        actline->prev = NULL;
        return;
      }  
      freest = actline;
      if (scrrow == FirstRow) 
        write_expr(FirstCol, FirstRow, LastRow, bottom, actline); 
      actline = actline->prev;
      if (freest == top) 
      {
	actline->next = NULL;
	top = actline;
      }
      else
      {
	actline->next = freest->next;
	freest->next->prev = actline;
      }
      actpos = actline->lastpos;
      if (scrrow != FirstRow) scrrow--;
      scrcol = actpos + FirstCol;
      move(scrrow, scrcol);
      refresh();
  }
  return;
} /* chkprevline */

/******************************************************************/
static void inloop(ll,FirstCol, FirstRow, LastRow)
int ll;  /* linelength and firstcol */
posint FirstCol, FirstRow, LastRow;
/* editorloop for input */
{ char ch;
	for(;;) {
		chknextline(ll,FirstCol, FirstRow, LastRow);
		switch(ch = getch()) {
		case qch: /* quit */
			  chkprevline(FirstCol, FirstRow, LastRow); 
			  if ((actline == top) && (actline->info[actline->lastpos] != 0)) ++(actline->lastpos);
                          if ((actline != top) && (actline->info[actline->lastpos] == 0)) --(actline->lastpos);

			  return;
		case BACKSPACE: /* delete last character */
			  if (actpos > 0) {
				actline->info[--(actline->lastpos)] = '\0';
				actpos--; scrcol--;
			  }
			  else chkprevline(FirstCol, FirstRow, LastRow);
			  mvaddch(scrrow,scrcol,' ');
			  move(scrrow,scrcol);
                          refresh();
			  break;
		case spacech: 
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
		case 'G':
		case 'H':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case complch: 
		case minusch:
		case insecch: 		
		case concatch:
		case unionch: 
		case starch:
		case plusch:
		case langch:
		case epsch:
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'h':
		case 'i':
		case 'j':
		case 'k':
		case 'l':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 's':
		case 't':
		case 'u':
		case 'v':
		case 'w':
		case 'x':
		case 'y':
		case 'z': 
		case 'a': 
		case '0': 
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case '(':
		case ')': stdaction;
			  break;
		default : /* wrong action do nothing */;
	}	}
} /* inloop */


/******************************************************************/
static void predef(state)
STATE_OF_EDITOR state;
/* prepares vars for the definition on an abbreviation
 * all values are stored in old-vars and then the normal
 * input-editor is called
 */
{
/* save values */
  state->scrrow = scrrow;
  state->scrcol = scrcol;
  state->actpos = actpos; 
  state->actline  = actline; 
  state->top = top;
  state->bottom = bottom;

  /* init values */
  
  actpos = 0;
  newab(maxdef-'A'); actline = ablist[maxdef-'A']->info;
  top = (bottom = actline);
  mvaddch(BOXSROW + 1, FIRSTCOL, maxdef); clrtoeol();
  mvaddch(BOXSROW + 1, FIRSTCOL + 1, ':'); clrtoeol();
  scrrow = BOXSROW + 2; scrcol = FIRSTCOL;
  
  return;
} /* predef */
/******************************************************************/
static void enddef(state)
STATE_OF_EDITOR state;
{
  strstack Pt = top;
  posint AbLen = 0;

  if (Pt->lastpos <= 0) 
  {
    Pt = Pt->prev;
    Pt->next = NULL;
  }
  if (Pt->info[Pt->lastpos] == '\0') --Pt->lastpos;
  for(; Pt != NULL; Pt = Pt->prev) 
    AbLen += (Pt->lastpos + 1);
  ablist[maxdef-'A']->length = AbLen;
  ablist[maxdef-'A']->info = bottom;
  builddef('A');

/* restore values */
  scrrow = state->scrrow;
  scrcol = state->scrcol;
  actpos = state->actpos; 
  actline  = state->actline; 
  top = state->top;
  bottom = state->bottom;

  return;
}
/******************************************************************/
static void defal(ml)
posint ml;
/* constructs the abbreviation 'A' for the alphabet */
{ posint i,j,length;
  posint ii,il;
  char *is;
  char *act;
  strstack actab,hlp;
	maxdef = 'A';
	newab(0);
	actab = ablist[0]->info;
	act = actab->info;
	act[0] = '('; act[1] = 'a'; j=2; length = 2;
	if (ml <= ALPHSIZE) {
		for(i=2; i<=ml; i++) {
			if (j >= DEFLENGTH-15) {
				defrow++;
				act[j] = '\0';
				actab->lastpos = j-1;
				j = 0;
				newpart(hlp);
				hlp->prev = actab;
				actab->next = hlp;
				actab = hlp;
				act = actab->info;
			}
			act[j++] = spacech;
			act[j++] = unionch;
			act[j++] = spacech;
			act[j++] = itoc[i];
			length += 4;
		}
		actab->lastpos = j;
		act[j++] = ')'; length++;
		act[j] = '\0';
	} else {
		act[j++] = '1'; length++;
		for(i=2; i <= ml; i++) {
			is = pi2a(i); il = strlen(is);
			if (j+il >= DEFLENGTH-15) {
				defrow++; act[j] = '\0';
				actab->lastpos = j-1; j=0;
				newpart(hlp);
				hlp->prev = actab;
				actab->next = hlp;
				actab = hlp;
				act = actab->info;
			}
			act[j++] = spacech;
			act[j++] = unionch;
			act[j++] = spacech;
			act[j++] = 'a';
			length += 4;
			for(ii = 0; ii < il;) {
				act[j++] = is[ii++];
				length++;
			}
		}
		actab->lastpos = j;
		act[j++] = ')'; length++;
		act[j] = '\0';
	}
	ablist[0]->length = length;
} /* defal */

/******************************************************************/
static void saverex(re)
regex re;
/* copies all information to the reg.expr. structure */
{ strstack pt;
  posint strl;
  posint i,j;
	strl = 0;
	if (top->lastpos <= 0) pt = top->prev; /* empty line */
	else { if (top->info[top->lastpos] == '\0') --top->lastpos; 
               pt = top; }
	while (pt != NULL) {
		strl++;
		strl += pt->lastpos;
		pt = pt->prev;
	}
	re->rexl = strl;
	re->rex = newrexstr(strl);
	re->rex[strl] = '\0';
	strl = 0;
	pt = bottom;
	while (pt != NULL) {
		for(i=0; i <= pt->lastpos;)
			re->rex[strl++] = pt->info[i++];
		pt = pt->next;
	}
	re->useda = maxdef - 'A';
	for(i=0; i <= re->useda; i++) {
		strl = ablist[i]->length;
		re->abbr[i] = newrexstr(strl);
		re->abbl[i] = strl;
		re->abbr[i][strl] ='\0';
		strl = 0;
		pt = ablist[i]->info;
		while (pt != NULL) {
			for(j=0; j <= pt->lastpos;)
				re->abbr[i][strl++] = pt->info[j++];
			pt = pt->next;
		}
	}
} /* saverex */

/******************************************************************/
static strstack gluelines() 
/* copies all information to the reg.expr. structure */
{ strstack pt;
  posint strl = 0;
  strstack RetString = new_strstack();

  if (top->lastpos <= 0) pt = top->prev; /* empty line */
  else
  { 
    if (top->info[top->lastpos] == '\0') --top->lastpos; 
    pt = top; 
  }
  while (pt != NULL)
  {
    strl += (pt->lastpos + 1);
    pt = pt->prev;
  }
  RetString->lastpos = strl;
  RetString->info = new_string(strl + 1);
  strl = 0;
  pt = bottom;
  while (pt != NULL) 
  {
    strcpy(&RetString->info[strl], pt->info);
    strl += (pt->lastpos + 1);
    pt = pt->next;
  }

  return RetString;
} /* gluelines */
/******************************************************************/
static void makelines(Expr)
strstack Expr;
{
  strstack LastPt, Pt = bottom;
  posint LastPos = Expr->lastpos, 
         Pos = 0,
         llm9 = linelength - 9;
  string Str = Expr->info;
  
  Pt->prev = NULL;
  while (Pos < LastPos)
  {
    memcpy(Pt->info, &Str[Pos],llm9);
    Pt->lastpos = llm9 - 1;
    Pos += llm9;
    LastPt = Pt;
    Pt = Pt->next;
  }
  LastPt->lastpos = LastPos - (Pos - llm9);
  LastPt->next = NULL;
  top = LastPt;
  actline = bottom;

  return;
}  

  
/******************************************************************/
static void initab(s,re)
char s;	/* last used letter + 1 */
regex re;
/* initialization proc for the abbreviation array */
{ strstack pt,hlp;
  posint j,k,l,m;
	defal(maxlet);	/* define the alphabet */

	for(j=1; j+'A'<= s; j++) {	/* used abbreviations */
		/* copy information */
		l = re->abbl[j];
		newab(j);
		ablist[j]->length = l;
		/* break string in parts */
		pt = ablist[j]->info;
		m = 0;
		while (l) {
			k = 0;
			while (l && (k < DEFLENGTH-15)) {
				pt->info[k++] = re->abbr[j][m++]; l--;
			}
			pt->info[k] = '\0'; pt->lastpos = k-1;
			if (l) {
				newpart(hlp);
				hlp->prev = pt;
				pt->next = hlp;
				pt = hlp;
	}	}	}
} /* initab */

/******************************************************************/
static void initrex(Expr)
strstack Expr;
/* init-proc for the regular expression; from the string Expr
 * the array pt->info is initialized */
{ strstack pt;	/* the act. line */
  posint i,j; /* i in line; j in Expr */
	pt = bottom; 
	/* break string in lines */
	for(j = 0; j <= Expr->lastpos;) {
		for(i = 0; i < linelength - 9; i++) {
			if (j > Expr->lastpos) break;
			switch(pt->info[i] = Expr->info[j++]) {
				case starch:
				case plusch:
				case 'A':
				case 'B':
				case 'C':
				case 'D':
				case 'E':
				case 'F':
				case 'G':
				case 'H':
				case 'I':
				case 'J':
				case 'K':
				case 'L':  /* XXX MAXLET */
				case 'b':
				case 'c':
				case 'd':
				case 'e':
				case 'f':
				case 'g':
				case 'h':
				case 'i':
				case 'j':
				case 'k':
				case 'l':
				case 'm':
				case 'n':
				case 'o':
				case 'p':
				case 'q':
				case 'r':
				case 's':
				case 't':
				case 'u':
				case 'v':
				case 'w':
				case 'x':
				case 'y':
				case 'z':
				case langch:
				case epsch: break;
				case '(':  break;
				case ')':  break;
				case 'a':  break;
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9': break;
				default: ;
				}
			}
		pt->info[i--] = '\0'; pt->lastpos = i;
		if (j <= Expr->lastpos) {
			newpart(pt->next);
			pt->next->prev = pt; pt = pt->next;
		}
	}
	actline = pt; top = pt;
} /* initrex */

/******************************************************************/
static void preinput()
/* prepares the input-editor */
{ strstack hlp;
  int i,j;
	/* create new line between actline and actline->next */ 
	newpart(hlp);
	hlp->next = actline->next;
	hlp->prev = actline;
	if (actline != top) actline->next->prev = hlp;
	else top = hlp;
	actline->next = hlp;

	/* copy restline of actline to hlp */
	for(i=actpos, j=0; i<=actline->lastpos; i++, j++) {
		hlp->info[j] = actline->info[i];
		actline->info[i] = '\0';
	}
	actline->lastpos = actpos;
	hlp->lastpos = j-1; hlp->info[j] = '\0';
} /* preinput */

/******************************************************************/
static char initre(re)
regex re;
{ char nxtdef; /* last definition letter */
  strstack Expr;
  
	/* init vars */
	linelength = COLS - FIRSTCOL - 5;
	maxlet = re->sno;
	
	if (re->useda > 0) {
		/* some defs known */
		nxtdef = 'A' + re->useda;
		initab(nxtdef,re); maxdef = nxtdef;
	} else { /* no defs; create alphabet */
		defal(maxlet); nxtdef = 'A';
	}

	actpos = 0; 
	newpart(bottom);
	top = bottom;
        if(re->rexl)
          {
           newpart(Expr);
           Expr->info = re->rex;
           Expr->lastpos = re->rexl;
           initrex(Expr);
          }
	actline = bottom;
	scrrow = FIRSTROW; scrcol = FIRSTCOL;

	return nxtdef;
} /* initre */
/******************************************************************/
/* Initialize the mapping {operators}->|{operators}| */
/* The mapping is only used for the precedence-table */
/* If this mapping is changed, the precedence table must be changed too */

static void init_index(index)
array index;
{
   index[unionch]    = 0;
   index[minusch]    = 1;
   index[insecch]    = 2;
   index[concatch]   = 3;
   index[complch]    = 4;
   index[plusch]     = 5;
   index[starch]     = 6;
   index[leftbrch]   = 7;
   index[rightbrch]  = 8;
   index[identch]    = 9;
   index[endch]      = 10;
   return;
}


/******************************************************************/
static EDIT_RESULT editor(parms)
EDIT_PARMS parms;
/* editor for regular expressions 
 *
 * structure of a line:
 *   actline->info[actpos]	character at position actpos
 */
{
   char ch;
   PARSE_RESULT res;
   posint FirstRow = parms->firstrow,  
          LastRow  = parms->lastrow,
          FirstCol = parms->firstcol,
          i;
   boolx InpMode;
   boole edit = parms->edit,
         def  = parms->def;
   PARSE_INPUT parse_parms = parms->parse_parms;
   EDIT_RESULT outres = new_edit_res();
   
   InpMode = (edit) ? ((def) ? DEFINP : NORMAL) : NOEDIT;  
   error_message = new_string(1);    
   tutor(COMMA, InpMode);
   write_expr(FirstCol, FirstRow, LastRow, bottom, actline);


	/* command loop */
	for(;;) {
		switch(ch = getch()) {
		case 'I':
		case 'i': /* go to input mode */
			  if (!edit) break;
                          tutor(INPUT, InpMode);
			  if ((actline != top) || (actline->lastpos > actpos))
                          {
                            preinput(); 
                            write_expr(FirstCol, FirstRow, LastRow, bottom, actline);
                            inloop(linelength,FirstCol, FirstRow, LastRow);
                            makelines(gluelines());
                            actpos = 0; 
                            scrcol = FirstCol;
                            write_expr(FirstCol, FirstRow, LastRow, bottom, actline);
                          } 
                          else inloop(linelength,FirstCol, FirstRow, LastRow);
			  error_message[0] = '\0';
                          tutor(COMMA, InpMode);
			  break;

		case 'H':
		case 'h': if (actpos) {
				actpos--; scrcol--; move(scrrow, scrcol); 
                                refresh();
			  } break;
		case 'J':
		case 'j': if (actline != top) {
				actline = actline->next;
				if (actline->lastpos < actpos) {
					actpos = actline->lastpos;
					scrcol = FirstCol + actpos;
				}
				if (scrrow +1 == LastRow) {
					scrrow = FirstRow+1;
					write_expr(FirstCol, FirstRow, LastRow, bottom, actline);
				} else {scrrow++; move(scrrow, scrcol); 
                                        refresh();}
			  } break;
		case 'K':
		case 'k': if (actline != bottom) {
				actline = actline->prev;
				if (actline->lastpos < actpos) {
					actpos = actline->lastpos;
					scrcol = FirstCol + actpos;
				}
				if (scrrow == FirstRow) {
				  write_expr(FirstCol, FirstRow, LastRow, bottom, actline);
				} else { scrrow--; move(scrrow, scrcol); refresh(); }
			  } break;
		case 'L':
		case 'l': if (actpos < actline->lastpos) {
				actpos++; scrcol++; move(scrrow, scrcol); refresh();
			  } break;
		case 'Q': /* quit */
		case 'q': if (!edit) { outres->nextkey = ch; return outres; } 
                          parse_parms->buf = bottom;
                          if (top->info[top->lastpos] == 0) --top->lastpos;
			  res = parser(parse_parms);
			  if (top->info[top->lastpos] != 0) ++top->lastpos;
			  if (res->tree != NULL) 
			  {
                                outres->tree = res->tree;
				outres->nextkey = ch;
				return outres; 
			  }		
			  error_message =  res->error_message;
                          actline = bottom;
                          for (i = 0; i < res->error_line; ++i)
                            actline = actline->next;
                          scrcol = FirstCol + res->error_pos;
                          actpos = res->error_pos;
                          write_expr(FirstCol, FirstRow, LastRow, bottom, actline);
                          mvaddstr(LASTROW,LRCOL, error_message);
                          move(scrrow, scrcol);
                          refresh();
			  break;
                case 'S':
                case 's': if ((def) || (FirstDef > maxdef)) break;
	                  scrolldef(); 
                          break;
 		case 'D': ;
                case 'd': if (def || (!edit)) break;
                    	  outres->nextkey = ch;
                          return outres;
		default : ;
	}	}
} /* editor */

/******************************************************************/
void edrex(re, edit)
regex re;
boole edit;
{
  posint IdLineSize, LetLen, i, j, IdListP;
  string LetNum, IdLine;
  EDIT_PARMS  edparms = new_edit_parms();
  EDIT_RESULT edres;
  PARSE_INPUT parse_parms = new_parse_input();
  PARSE_RESULT parse_res;
  EXPRESS RexInPostfix;
  arrayofarray   precedence;
  boole endedit;
  boole isreg;

   /* The precedence table */
  static posint prec[11][11] =
  {
/*         U        -        &        .        ~        +        *    */
/*         (        )        ?        $                               */
     { GREATER, LESS,    LESS,    LESS,    LESS,    LESS,    LESS,   /* U */
        LESS,    GREATER, LESS,    GREATER},

     { GREATER, GREATER, LESS,    LESS,    LESS,    LESS,    LESS,   /* - */
        LESS,    GREATER, LESS,    GREATER},

     { GREATER, GREATER, GREATER, LESS,    LESS,    LESS,    LESS,   /* & */ 
        LESS,    GREATER, LESS,    GREATER},

     { GREATER, GREATER, GREATER, GREATER, LESS,    LESS,    LESS,   /* . */
        LESS,    GREATER, LESS,    GREATER},

     { GREATER, GREATER, GREATER, GREATER, LESS,    LESS,    LESS,   /* ~ */
        LESS,    GREATER, LESS,    GREATER},

     { GREATER, GREATER, GREATER, GREATER, GREATER, GREATER, GREATER,/* + */
        UNUSED,  GREATER, UNUSED,  GREATER},

     { GREATER, GREATER, GREATER, GREATER, GREATER, GREATER, GREATER,/* * */
        UNUSED,  GREATER, UNUSED,  GREATER},

     { LESS,    LESS,    LESS,    LESS,    LESS,    LESS,    LESS,   /* ( */
        LESS,    EQUAL,   LESS,    UNBALBR},
     
     { GREATER, GREATER, GREATER, GREATER, UNUSED,  GREATER, GREATER,/* ) */
        UNUSED,  GREATER, UNUSED,  GREATER},

     { GREATER, GREATER, GREATER, GREATER, GREATER, GREATER, GREATER,/* ? */
        UNUSED,  GREATER, UNUSED,  GREATER},

     { LESS,    LESS,    LESS,    LESS,    LESS,    LESS,    LESS,   /* $ */
        LESS,    UNBARBR, LESS,    ENDTEXT},
 
  };

  static char op_list[] = "( ) ~ + * U . & - ? $"; 
  /* endch ($) must be included here !! */
  /* identch(?) must be included here !! */
 
  static char rule1[] = "E->?|(E)|E&E|E.E|E-E|EUE|E*|E+|~E";

  STATE_OF_EDITOR state = new_editor_state();
  

  AbbsInPostfix = (EXPRESS *) newbuf(NABBR, sizeof(EXPRESS));
/* initialize the variables */
  initre(re);

  if (maxlet > ALPHSIZE)  
  {
    IdLineSize = 9 * 3 + 3 + (MAXLET - 'A' + 1) * 2;
    LetLen = 4; i = 10;
    do
    {
      IdLineSize += (maxlet > (i * 10)) ? (9 * i * LetLen) : ((maxlet - i + 1) * LetLen);
      ++LetLen; i *= 10;
    } while (maxlet > i);
  }
  else IdLineSize = maxlet * 2 + 3 + (MAXLET - 'A' + 1) * 2;

  IdLine = new_string(IdLineSize + 1);
  if (maxlet > ALPHSIZE)
    for (i = 1, IdListP = 0; i <= maxlet; ++i)
    {
      IdLine[IdListP++] = 'a';
      LetNum = pitos(i);
      strcpy(&IdLine[IdListP], LetNum);
      IdListP += strlen(LetNum);
      IdLine[IdListP++] = spacech;
    }
  else
    for (i = 1, IdListP = 0; i <= maxlet; ++i)
    {
      IdLine[IdListP++] = itoc[i];
      IdLine[IdListP++] = spacech;
    }
  IdLine[IdListP++] = epsch;
  IdLine[IdListP++] = spacech;
  IdLine[IdListP++] = langch;
   
  parse_parms->op_list = new_string(strlen(op_list) + 1);  
  strcpy(parse_parms->op_list, op_list);
 
  parse_parms->id_list = IdLine;  
  
  parse_parms->rules = new_strar(1);
  parse_parms->rules[0] = new_string(strlen(rule1) + 1);
  strcpy(parse_parms->rules[0], rule1);

  parse_parms->maxrule  = 9;     /* Nine rules in the grammar (count 'em) */
  parse_parms->startsymbol = 'E';
   
  precedence = (arrayofarray) newbuf(11, sizeof(array));

  for (i = 0; i < 11; ++i)
  {
    precedence[i] = (array) newbuf(11, sizeof(posint));
    for (j = 0; j < 11; ++j) precedence[i][j] = prec[i][j];
  }

  parse_parms->precedence = precedence;
 
  parse_parms->index = new_array(MAXCHAR);
  init_index(parse_parms->index);

  parse_parms->buf = bottom;
  edparms->firstcol = FIRSTCOL;
  edparms->firstrow = FIRSTROW;
  edparms->lastrow = LASTROW;
  edparms->edit = edit;
  edparms->def = FALSE;
  edparms->rex = re;
  edparms->parse_parms = parse_parms;

  edparms->parse_parms->buf = new_strstack();
 
  for (i = 0; i <= (maxdef - 'A'); ++i)
  {
    edparms->parse_parms->id_list[IdListP++] = spacech;
    edparms->parse_parms->id_list[IdListP++] = 'A' + i;
    edparms->parse_parms->buf = ablist[i]->info;
    parse_res = parser(edparms->parse_parms);
    if (parse_res->tree != NULL) AbbsInPostfix[i] = tree2string(parse_res->tree);
    else errex(SWERR, "EDREX: Abbreviation syntactically incorrect\n");
  }

  clear(); buildscr(maxlet); builddef('A');

  endedit = FALSE;
  do
  {
    edres = editor(edparms);
    switch (edres->nextkey)
    {
      case 'D':
      case 'd': if (!edit) break;  
	        if (maxdef < MAXLET)
                { 
                  ++maxdef;
                  predef(state);
                  edparms->def = TRUE;
                  edparms->firstrow = BOXSROW + 2;
                  edparms->lastrow = BOXEROW;
                  edres = editor(edparms);
                  AbbsInPostfix[maxdef - 'A'] = tree2string(edres->tree);
                  enddef(state);
                  edparms->firstcol = FIRSTCOL;
                  edparms->firstrow = FIRSTROW;
                  edparms->lastrow = LASTROW;
                  edparms->def = FALSE;
                  edparms->parse_parms->id_list[IdListP++] = spacech;
                  edparms->parse_parms->id_list[IdListP++] = maxdef;
                }
	        break;
      case 'Q': 
      case 'q': if (!edit) { freebuf(); return; }
                if (!edparms->def) endedit = TRUE;
                else edparms->def = FALSE;
                break;
      default: /* Should not happen */;
    }
  } while (!endedit);

  saverex(re);
  RexInPostfix = tree2string(edres->tree);
  re->exprex = newrexstr(RexInPostfix->length);
  strcpy(re->exprex, RexInPostfix->expr);
  re->erexl = RexInPostfix->length;
  /* test whether expression is regular (without ~,-,&) */
  isreg = TRUE;
  for(i=0;(i<re->erexl)&&isreg;++i)
    if((re->exprex[i] == minusch) || (re->exprex[i] == complch) || (re->exprex[i] == insecch))
      isreg=FALSE;
   re->grex=(!isreg);
  freebuf();
  return;
}
