#ifndef EXT_H
#define EXT_H

/* ext.h 3.0 (KIEL) 11.94 */

/******************************************************************/
#include <setjmp.h>
#include <stdio.h>
#include <ctype.h> 
#include <string.h>

#ifdef UNIX	
#include <curses.h> 
#include <sys/param.h>
#endif        

#ifdef DOS
#include <malloc.h>
#include <conio.h>
#include <stdlib.h>
#endif


#include "cons.h"
#include "types.h"
#include "error.h"

#ifdef UNIX
#include "unix.h"
#endif

#include "func.h"

#ifndef AMORE
/* global variables */
extern language langs[NLANG];
extern language curlan;
extern language mlang;

extern int 	 curidx;
extern int 	 maxidx;

extern char itoc[28];

extern char menu;
extern char workdir[PATHLEN];
extern char printdir[PATHLEN];
extern char displaydir[PATHLEN];
extern char amddir[PATHLEN];
extern boole tickon;

extern jmp_buf env;

extern char dummy[PILEN];

extern unsigned long comptime;


extern int plines;
extern int pcols;
extern char *lpdest;

extern FILE *amrp;
extern char line[LINELEN1];
extern char *text[];

#endif

/* actions for nodeterministic automata
 * Abbr.: Delta Letter From To
 * connect: make transition in D from F to T with Letter L
 * disconnect: destroy connection
 * testcon: TRUE iff connection exists
 * cpdelta: copy all connections in D2 non-destructive to D1
 * lastdelta: max. value for the 2nd state loop
 */
#define connect(D,L,F,T)\
     D[L][F][(T)/SIZEOFBYTE] |= 0x1 << ((T)%SIZEOFBYTE)
#define disconnect(D,L,F,T)\
     D[L][F][(T)/SIZEOFBYTE] &= ~(0x1 << ((T)%SIZEOFBYTE))
#define testcon(D,L,F,T)\
     (D[L][F][(T)/SIZEOFBYTE] & (0x1 << ((T) % SIZEOFBYTE)))
#define cpdelta(D1,L1,F1,T1,D2,L2,F2,T2)\
     {if(testcon(D2,L2,F2,T2)) connect(D1,L1,F1,T1);}
#define lastdelta(MAX_QNO)	((MAX_QNO+1) / SIZEOFBYTE)

/* actions for final and initial */
#define isfinal(A)	((A) & FINMASK)
#define setfinal(A,B)	{if ((B)) A |= FINMASK; else A &= ~FINMASK;}
#define setfinalT(A)     A |= FINMASK
#define setfinalF(A)     A &= ~FINMASK
#define isinit(A)	((A) & INMASK)
#define setinit(A)	A |= INMASK
#define rminit(A)	A &= ~INMASK

/* memory management with the buffer */
#define newmonoid()		(monoid)newbuf((posint)1,(posint)sizeof(struct mono))
#define newarray(A)		(array)newbuf((posint)(A),(posint)sizeof(posint))
#define newfin(A)		(mrkfin)newbuf((posint)(A),(posint)sizeof(boolx))
#define newb_array(A)		(b_array)newbuf((posint)(A),(posint)sizeof(boole))
#define newarrayofarray(A)	(arrayofarray)newbuf((posint)(A),(posint)sizeof(array))
#define newarrayofb_array(A)	(arrayofb_array)newbuf((posint)(A),(posint)sizeof(b_array))
#define newstring(A)		(string)newbuf((posint)(A),(posint)sizeof(char))
#define newarrayofstring(A)	(arrayofstring)newbuf((posint)(A),(posint)sizeof(string))

/* memory management with calloc */
#define dispose(A)		(free((char *)A))
#ifdef TICK_COUNT
# define tick()	tack()
#else
# define tick()
#endif


/* special routines */
#define inputpos	{ move(INPROW,INPCOL); clrtoeol(); addstr("INPUT >>> "); }

#define cleartut()	{ move(LASTROW+2,LRCOL); clrtoeol(); \
			  move(LASTROW+1,LRCOL); clrtoeol(); \
        		  move(LASTROW,LRCOL); clrtoeol();}

#define fwrite(A)	(void)fputs(A,amrp)
#define new_line	(void)fputs("\n",amrp)
#define frdin()		(void)fgets(line,LINELEN1,amrp)

#ifdef DOS
#define  cbreak()		/* Lu-Go 29.11.91 */
#define  crmode()
#define  echo()			/* Lu-Go 29.11.91 */
#define  endwin()
#define  gtyx(A,B,C)  getyx(&B,&C)
#define  initscr()  clear()
#define  nocbreak()		/* Lu-Go 29.11.91 */
#define  nocrmode()
#define  noecho()
#define  nonl()
#define  refresh()
#define  sleep(A)
#endif

#ifdef UNIX
#define gtyx(A,B,C)  getyx(A,B,C)
#endif

#endif EXT_H
