/* main.c 3.0 (KIEL) 11.94 */

#define AMORE
#include "ext.h"
#include "extbis.h"    /* --- Bordeaux : 1995 --- */
#include "vars.h"
#include "amrtext.h"

#include <signal.h>

/* functions included:
 * 	static void  sighand()
 * 	static void  inthand()
 *	       void  catchsig()
 *	       void  main()
 */
/******************************************************************/
/*****************************************************************/
static void
sighand(sig)
int sig;
/* terminates curses and pgm with error message */
{	endcurses(FALSE);
	(void)printf("\n\n             SYSTEM ERROR !!!\n\n");
	switch(sig) {
	case SIGINT: (void)printf("Caught SIGINT (interrupt)"); break;
	case SIGILL: (void)printf("Caught SIGILL (illegal instruction)"); break;
	case SIGSEGV: (void)printf("Caught SIGSEGV (segmentation violation)"); break;
#ifdef UNIX
	case SIGSYS: (void)printf("Caught SIGSYS (bad system call)"); break;
	case SIGHUP: (void)printf("Caught SIGHUP (hangup)"); break;
	case SIGQUIT: (void)printf("Caught SIGQUIT (quit)"); break;
	case SIGKILL: (void)printf("Killed"); break;
	case SIGBUS: (void)printf("Caught SIGBUS (bus error)"); break;
#endif


#ifdef SIGWIND
	case SIGWIND: (void)printf("Caught SIGWIND (window change)"); break;
#endif
	}
	(void)printf("\n\n            Goodbye from AMORE\n\n");
#ifdef DEBUG
	abort();
#else
	exit(sig);
#endif
} /* sighand */

/******************************************************************/
static void
inthand(sig)
int sig;
{
	buffree(); freebuf(); clock_reset();
#ifdef DOS
	(void) signal(SIGINT,inthand);
#endif
	(void)longjmp(env,3);
} /* inthand */

/******************************************************************/
void
catchsig()
/* set signal handler to sighand */
{
  void sighand();
  void inthand();

	(void) signal(SIGINT,inthand);
	(void) signal(SIGILL,sighand);
	(void) signal(SIGSEGV,sighand);
#ifdef UNIX
	(void) signal(SIGSYS,sighand);
	(void) signal(SIGQUIT,sighand);
	(void) signal(SIGHUP,sighand);
	(void) signal(SIGKILL,sighand);
	(void) signal(SIGBUS,sighand);
#endif


#ifdef SIGWIND
	(void) signal(SIGWIND,sighand);
#endif
} /* catchsig */

/******************************************************************/
static void
initenv()
{
char *env;

	una2operations = FALSE;        /* --- Bordeaux : 1995 --- */	

	/* the directory information */
	workdir[0] = '\0';
	env=getenv("AMOREDIR");
	if (env != NULL)
	    (void)strcpy(workdir,env);
	else 
	   {
	    (void)printf("Please set environment variable AMOREDIR; cf. file readme \n"); 
            exit(1);
           } 
	if (strlen(workdir) >= (size_t)PATHLEN)
           {
	    (void)printf("PATHLEN too small"); 
            exit(1);
	   }
	(void)strcat(workdir,PATHSTR);
	printdir[0] = '\0';
	env=getenv("PRINTDIR");
	if (env != NULL)
		(void)strcpy(printdir,env);
	else 
	   {
	    (void)printf("Please set environment variable PRINTDIR; cf. file readme \n"); 
            exit(1);
           }
	if (strlen(printdir) >= (size_t)PATHLEN) 
           {
	    (void)printf("PATHLEN too small"); 
             exit(1);
	   }
	(void)strcat(printdir,PATHSTR);
#ifdef DISPLAY 
        displaydir[0] = '\0';
	env=getenv("DISPLAYDIR");
	if (env != NULL)
		(void)strcpy(displaydir,env);
	else 
	   {
	    (void)printf("Please set environment variable DISPLAYDIR; cf. file readme \n"); 
            exit(1);
           }
	if (strlen(displaydir) >= (size_t)PATHLEN) 
           {
	    (void)printf("PATHLEN too small"); 
             exit(1);
	   }
	(void)strcat(displaydir,PATHSTR);
        amddir[0] = '\0';
	env=getenv("AMDDIR");
	if (env != NULL)
		(void)strcpy(amddir,env);
	else 
	   {
            (void)printf("No directory defined!");
            exit(1);
           }
	if (strlen(amddir) >= (size_t)PATHLEN) 
           {
	    (void)printf("PATHLEN too small"); 
             exit(1);
           }
#endif
	env=getenv("AMORELPR");
	if (env == NULL) 
               {
		plines = DEFAULT_PLINES;
		pcols  = DEFAULT_PCOLS;
		lpdest = NULL;
	       } 
        else 
               {
		(void)sscanf(strtok(env," ,"),"%d",&plines);
		(void)sscanf(strtok((char *)NULL," ,"),"%d",&pcols);
		lpdest = strtok((char *)NULL," ");
	       }
} /* initenv */

/******************************************************************/
/******************************************************************/
void main ()
{
	catchsig();               /* catch some signals */
	initbuf();
	tickon = TRUE;
	initenv();                /* initialize environment */
	initcurses();		  /* initialize curses */
	/* if terminal dimensions too small initcurses exits */
	drawmenu(menu=VERSMENU);  /* version */
        drawmenu(menu=LANGMENU);  /* draw the menu */
	evalkey();		  /* get keystrokes */
	endcurses(TRUE);	  /* end curses */
} /* main */




