/* menu.c 3.1 (KIEL) 01.95 */

#include "ext.h"
#include "menu.h"

#include "extbis.h" /* --- Bordeaux : 1995 --- */

/* functions included:
 *
 *		void  headbox()
 *	static	void  fillbox()
 *
 *		void  maketitle()
 *		void  drawmenu()
 *		void  inpmenu()
 *		void  updatewin();
 */

#define pout(A) { if (maxidx) switch(curlan->A){ \
						 case UN_KNOWN: addstr(" ? "); break; \
						 case TRUE    : addstr("Yes"); inp = TRUE; break; \
						 case FALSE   : addstr("No ");}\
		  else addstr(" ? "); }

#define VERSION ("LaBRI  02/05/95")  /* --- Bordeaux : 1995 --- */

/******************************************************************/
/******************************************************************/
void
headbox(srow,scol,erow,ecol,txt)
     int  srow,scol,erow,ecol;
     char *txt;
/* draw a box starting at (srow,scol) and ending at (erow,ecol)
 * the headline looks like this:  ==== txt ====
 * NO RETURN
 */
{
  int i,t;
  
  /* compute start position of txt in the headline */
  t = (ecol + scol - 2)/2; 
  t -= ((int) strlen(txt)/ (size_t) 2);
  
  /* the headline: "=" to the left of txt, a blank, txt, a blank
   * and "=" to the right of txt 
   */
  for(i=scol; i < t; mvaddch(srow,i++,'='));
  mvaddch(srow,i++,' ');
  mvaddstr(srow,i++,txt); /* i++ to produce the second blank */
  for(i+=strlen(txt); i <= ecol; mvaddch(srow,i++,'='));
  
  if(srow!=erow)
    {
      /* the vertical lines with "|" (the corners are named '=') */
      for(i=srow; i++ < erow; ) 
	{
	  mvaddch(i,scol,'|'); /* the left column */
	  mvaddch(i,ecol,'|'); /* the right column */
	}
      
      /* the bottom line with "_" (the corners are named '|') */
      if (srow < erow)
	for(i=scol; ++i < ecol; mvaddch(erow,i,'_'));
    }
} /* headbox */

/******************************************************************/
static void
fillbox(box,inp)
     char box;
     boolx inp;
     /* fill the window specified by the character box (it is the first
      * letter of the window name) with the choices. 
      * inp is TRUE iff we are going to input a language (e.g. it is not allowed
      * to define a language by the minimal dfa).
      * NO RETURN
      */
{
  short i;
  switch(box) 
    {
    case EWIN: /* window Expression */
      mvaddstr(REXROW+3,REXCOL+2,"2. generalized expr.");
      if (!inp)
	{
	  mvaddstr(REXROW+4,REXCOL+2,"3. starfree expression");
	  mvaddstr(REXROW+2,REXCOL+2,"1. regular expression");
	}
      else 
	if(inp == UN_KNOWN)
	  {
	    mvaddstr(REXROW+2,REXCOL+2,"1. regular expression");
	    mvaddstr(REXROW+4,REXCOL+2,"                      ");
	  }
	else
	  {
	    mvaddstr(REXROW+4,REXCOL+2,"                      ");
	    mvaddstr(REXROW+2,REXCOL+2,"                      ");
	  }
      break;
    case MWIN: /* window Monoid */
      if (!inp)
	{
	  mvaddstr(MONROW+2,MONCOL+2,"1. elements,relations");
	  mvaddstr(MONROW+3,MONCOL+2,"2. Green's relations");
	  mvaddstr(MONROW+4,MONCOL+2,"3. multiplication table");
	} 
      else 
	{
	  mvaddstr(MONROW+2,MONCOL+2,"                     ");
	  mvaddstr(MONROW+3,MONCOL+2,"                    ");
	  mvaddstr(MONROW+4,MONCOL+2,"                       ");
	}
      break;
    case AWIN: /* window Automata */
      mvaddstr(AUTROW+2,AUTCOL+2,"1. det. automaton");
      mvaddstr(AUTROW+3,AUTCOL+2,"2. ndet. automaton");
      mvaddstr(AUTROW+4,AUTCOL+2,"3. epsilon automaton"); 
      if (!inp)
	{
	  mvaddstr(AUTROW+6,AUTCOL+2,"4. min. det. automaton");
	  mvaddstr(AUTROW+7,AUTCOL+2,"5. red. ndet. automaton");
	} 
      else
	{
	  mvaddstr(AUTROW+6,AUTCOL+2,"                      ");
	  mvaddstr(AUTROW+7,AUTCOL+2,"                       ");
	}
      break;
    case LWIN: /* window Languages */
      if (!inp) 
	{
	  mvaddstr(IDXROW,MARKCOL,  "  1.           ");
	  mvaddstr(IDXROW+1,MARKCOL,"  2.           ");
	  mvaddstr(IDXROW+2,MARKCOL,"  3.           ");
	  mvaddstr(IDXROW+3,MARKCOL,"  4.           ");
	  mvaddstr(IDXROW+4,MARKCOL,"  5.           ");
	  mvaddstr(IDXROW+5,MARKCOL,"  6.           ");
	  mvaddstr(IDXROW+6,MARKCOL,"  7.           ");
	  mvaddstr(IDXROW+7,MARKCOL,"  8.           ");
	  mvaddstr(IDXROW+8,MARKCOL,"  9.           ");
	  for(i=0; i<maxidx; i++)
	    mvaddstr(IDXROW+i,IDXCOL,langs[i]->name);
	  if (maxidx) mvaddstr(IDXROW+curidx,MARKCOL,"->");
	}
      else
	{
	  mvaddstr(IDXROW,MARKCOL,  "               ");
	  mvaddstr(IDXROW+1,MARKCOL,"               ");
	  mvaddstr(IDXROW+2,MARKCOL,"               ");
	  mvaddstr(IDXROW+3,MARKCOL,"               ");
	  mvaddstr(IDXROW+4,MARKCOL,"               ");
	  mvaddstr(IDXROW+5,MARKCOL,"               ");
	  mvaddstr(IDXROW+6,MARKCOL,"               ");
	  mvaddstr(IDXROW+7,MARKCOL,"               ");
	  mvaddstr(IDXROW+8,MARKCOL,"               ");
	}
      break;
    case LANG: /* window Commands */
      if (!inp) 
	{
	  mvaddstr(ACTROW+2,ACTCOL+2,"1. load");
	  mvaddstr(ACTROW+3,ACTCOL+2,"2. create");
	  mvaddstr(ACTROW+2,AOF   ,"3. modify");
	  mvaddstr(ACTROW+3,AOF   ,"4. delete");
	  mvaddstr(ACTROW+2,AOFF  ,"5. print");
	  mvaddstr(ACTROW+3,AOFF  ,"6. display");
	  switch (menu) 
	    {
	    case LANGMENU:
	      mvaddstr(ACTROW+2,AOFFF ,"7. test menu");
	      mvaddstr(ACTROW+3,AOFFF ,"8. assign menu");
	      break;
	    case TESTMENU:
	      mvaddstr(ACTROW+2,AOFFF ,"7. assign menu");
	      mvaddstr(ACTROW+3,AOFFF ,"8. repr. menu");
	      break;
	    case ASSIGNMENU:
	      mvaddstr(ACTROW+2,AOFFF ,"7. repr. menu");
	      mvaddstr(ACTROW+3,AOFFF ,"8. test menu");
	      break;
	    default: /* this should not happen */
	      errex(SWERR,"COMMAND WINDOW");
	    }
	  mvaddstr(ACTROW+2,AOFFFF,"9. save");
	  mvaddstr(ACTROW+3,AOFFFF,"0. exit AMORE");
	} 
      else 
	{
	  mvaddstr(ACTROW+2,ACTCOL+2,"       ");
	  mvaddstr(ACTROW+3,ACTCOL+2,"         ");
	  mvaddstr(ACTROW+2,AOF   ,"         ");
	  mvaddstr(ACTROW+3,AOF   ,"         ");
	  mvaddstr(ACTROW+2,AOFF  ,"        ");
	  mvaddstr(ACTROW+3,AOFF  ,"          ");
	  mvaddstr(ACTROW+2,AOFFF ,"              ");
	  mvaddstr(ACTROW+3,AOFFF ,"              ");
	  mvaddstr(ACTROW+2,AOFFFF,"             ");
	  mvaddstr(ACTROW+3,AOFFFF,"             ");
	}
      break;
    case OWIN: /* window One language */
      mvaddstr(ONEROW+2,ONECOL+2,"1. L in FOLU        "); 
      pout(folu);
      mvaddstr(ONEROW+3,ONECOL+2,"2. L starfree       "); 
      pout(starfree);
      if ((maxidx) && (curlan->starfree == TRUE)) 
	{
	  mvaddstr(ONEROW+4,ONECOL+2,"3. dotdepth 1       "); 
	  pout(dotdepth1);
	  mvaddstr(ONEROW+5,ONECOL+2,"4. definite         "); 
	  pout(definite);
	  mvaddstr(ONEROW+6,ONECOL+2,"   reverse def.     "); 
	  pout(revdefinite);
	  mvaddstr(ONEROW+7,ONECOL+2,"   generalized def. "); 
	  pout(gendefinite);
	  mvaddstr(ONEROW+8,ONECOL+2,"   locally testable "); 
	  if(curlan->localtest!=TRUE) 
	    pout(localtest)
	  else 
	    if(curlan->localdegree==curlan->lmon->mno) 
	      pout(localtest)
	    else 
	      {
		addstr("   ");     /* delete previous yes,no,? */
		mvaddstr(ONEROW+8,ONECOL+2,"   locally testable "); 
		addstr(pi2a(curlan->localdegree));
	      }
	  mvaddstr(ONEROW+9,ONECOL+2,"   (co-)finite      "); 
	  pout(nilpotent);
	  mvaddstr(ONEROW+10,ONECOL+2,"5. piecewise test.  "); 
	  pout(piecetest);
	}
      else
	{
	  mvaddstr(ONEROW+4,ONECOL+2,"                       ");
	  mvaddstr(ONEROW+5,ONECOL+2,"                       ");
	  mvaddstr(ONEROW+6,ONECOL+2,"                       ");
	  mvaddstr(ONEROW+7,ONECOL+2,"                       ");
	  mvaddstr(ONEROW+8,ONECOL+2,"                       ");
	  mvaddstr(ONEROW+9,ONECOL+2,"                       ");
	  mvaddstr(ONEROW+10,ONECOL+2,"                       ");
	}
      mvaddstr(ONEROW+11,ONECOL+2,"6. L code           "); /* --- Bordeaux : 1995 --- */
      pout(code);                                          /* --- Bordeaux : 1995 --- */
      break;
    case TWIN: /* window Two languages */
      mvaddstr(TWOROW+2,TWOCOL+2,"1. L={} "); 
      pout(empty);
      mvaddstr(TWOROW+2,TWOCOL+ONEOFF," 2. L=A");
      addch(starch); addch(' ');
      pout(full);
      mvaddstr(TWOROW+4,TWOCOL+2,"3. L1 = L2 ?");
      mvaddstr(TWOROW+5,TWOCOL+2,"4. L1 in L2 ?");
      mvaddstr(TWOROW+6,TWOCOL+2,"5. L1 ");
      addch(insecch); 
      addstr(" L2 empty?");
      break;
    case UWIN: /* window unary op */
      mvaddstr(ONEROW+2,ONECOL+2,"1. L2 := L1"); 
      addch(starch);
      mvaddstr(ONEROW+3,ONECOL+2,"2. L2 := L1"); 
      addch(plusch);
      mvaddstr(ONEROW+4,ONECOL+2,"3. L2 := ");
      addch(complch); 
      addstr("L1");
      mvaddstr(ONEROW+5,ONECOL+2,"4. L2 := rev(L1)");
      mvaddstr(ONEROW+6,ONECOL+2,"5. L2 := min(L1)");
      mvaddstr(ONEROW+7,ONECOL+2,"6. L2 := max(L1)");
      mvaddstr(ONEROW+8,ONECOL+2,"7. L2 := pref(L1)");
      mvaddstr(ONEROW+9,ONECOL+2,"8. L2 := suff(L1)");
      mvaddstr(ONEROW+10,ONECOL+2,"9. ... Rest(R) ... ");   /* --- Bordeaux : 1995 --- */
      break;
    case U2WIN: /* Window Unary operations 2 */             /* --- Bordeaux : 1995 --- */ 
      mvaddstr(ONEROW+2,ONECOL+2,"1. L2 := Root(L1)");      /* --- Bordeaux : 1995 --- */
      mvaddstr(ONEROW+3,ONECOL+2,"2. L2 := Free-Hull(L1)"); /* --- Bordeaux : 1995 --- */
      mvaddstr(ONEROW+4,ONECOL+2,"3. L2 := L1");            /* --- Bordeaux : 1995 --- */
      addch(stackch);                                       /* --- Bordeaux : 1995 --- */
      break;                                                /* --- Bordeaux : 1995 --- */
    case BWIN: /* window binary op */
      mvaddstr(TWOROW+2,TWOCOL+2,"1. L3 := L1 ");
      addch(unionch);
      addstr(" L2");
      mvaddstr(TWOROW+3,TWOCOL+2,"2. L3 := L1 ");
      addch(insecch);
      addstr(" L2");
      mvaddstr(TWOROW+4,TWOCOL+2,"3. L3 := L1 ");
      addch(concatch);
      addstr(" L2");
      mvaddstr(TWOROW+5,TWOCOL+2,"4. L3 := L1 ");
      addch(minusch);
      addstr(" L2");
      mvaddstr(TWOROW+6,TWOCOL+2,"5. L3 := L1 W L2 ");
      mvaddstr(TWOROW+7,TWOCOL+2,"6. L3 := L1 LQ L2 ");
      mvaddstr(TWOROW+8,TWOCOL+2,"7. L3 := L1 RQ L2 ");
      break;
    default:  /* this should not happen */
      errex(SWERR,"FILLBOX");
    } /* end switch */
} /* fillbox */

/******************************************************************/
void
maketitle(center,txt)
     boole center;
     char *txt;
     /* prints txt in the center of TITLEROW iff center == TRUE
      * else use TITLECOL
      */
{ 
  int i;
  i = (COLS - 1 - (int) strlen(txt)) >> 1;
  if (center) 
    mvaddstr(TITLEROW,i,txt);
  else 
    mvaddstr(TITLEROW,TITLECOL,txt);
} /* maketitle */

/******************************************************************/
void
drawmenu(menuno)
     char menuno;
     /* create the menues
      * NO RETURN
      */
{ 
  boole showtime = FALSE;
  
  clear();
  refresh();
  switch(menuno)
    {
    case LANGMENU:
      maketitle(FALSE,"L A N G U A G E   R E P R E S E N T A T I O N S");
      headbox(REXROW,REXCOL,REXLIN,REXLEN,"Expressions");
      headbox(AUTROW,AUTCOL,AUTLIN,AUTLEN,"Automata");
      headbox(MONROW,MONCOL,MONLIN,MONLEN,"syntactic Monoid");
      headbox(LANROW,LANCOL,LANLIN,LANLEN,"Languages");
      headbox(ACTROW,ACTCOL,ACTLIN,ACTLEN,"General commands");
      
      inpmenu(LANGMENU,FALSE);
      mvaddstr(INPROW,INPCOL,"INPUT >>> ");
      showtime = TRUE;
      break;
    case TESTMENU:
      maketitle(FALSE,"               T E S T S");
  
      headbox(ONEROW,ONECOL,ONELIN,ONELEN,"One language");
      headbox(TWOROW,TWOCOL,TWOLIN,TWOLEN,"Two languages");
      headbox(LANROW,LANCOL,LANLIN,LANLEN,"Languages");
      headbox(ACTROW,ACTCOL,ACTLIN,ACTLEN,"General commands");
      inpmenu(TESTMENU,FALSE);
      mvaddstr(INPROW,INPCOL,"INPUT >>> ");
      showtime = TRUE;
      break;
    case ASSIGNMENU:
      maketitle(FALSE,"          A S S I G N M E N T S");

      if ( una2operations == FALSE )                              /* --- Bordeaux : 1995 --- */
	headbox(ONEROW,ONECOL,ONELIN,ONELEN,"Unary operation");   /* --- Bordeaux : 1995 --- */
      else                                                        /* --- Bordeaux : 1995 --- */
	headbox(ONEROW,ONECOL,ONELIN,ONELEN,"unaRy operation 2"); /* --- Bordeaux : 1995 --- */

      headbox(TWOROW,TWOCOL,TWOLIN,TWOLEN,"Binary operation");  
      headbox(LANROW,LANCOL,LANLIN,LANLEN,"Languages");
      headbox(ACTROW,ACTCOL,ACTLIN,ACTLEN,"General commands");
      inpmenu(ASSIGNMENU,FALSE);
      mvaddstr(INPROW,INPCOL,"INPUT >>> ");
      showtime = TRUE;
      break;
    case MAUTMENU:
      mvaddstr(MODROW,MODCOL,"Name of language to modify: ");
      addstr(mlang->name);
      mvaddstr(MODROW+1,MODCOL,"Reference: ");
      addstr(mlang->ref);
      mvaddstr(MODROW+2,MODCOL,"Size of the Alphabet: ");
      addstr(pi2a(mlang->sizeal));
      mvaddstr(MODROW+3,MODCOL,"Number of automaton states: ");
    case AUTMENU:
      maketitle(FALSE,"I N P U T:    A U T O M A T A");
      mvaddstr(NAMROW,NAMCOL,"Name of the language: ");
      mvaddstr(REFROW,REFCOL,"Reference: ");
      mvaddstr(ALPROW,ALPCOL,"Size of the Alphabet: ");
      mvaddstr(ALPROW+1,ALPCOL,"Call the letters    : ");
      mvaddstr(QNOROW,QNOCOL,"Number of automaton states: ");
      mvaddstr(QNOROW+1,QNOCOL,"Call the automaton states : ");
      showtime = FALSE;
      break;
    case MREXMENU:
      mvaddstr(MODROW,MODCOL,"Name of language to modify: ");
      addstr(mlang->name);
      mvaddstr(MODROW+1,MODCOL,"Reference: ");
      addstr(mlang->ref);
      mvaddstr(MODROW+2,MODCOL,"Size of the Alphabet: ");
      addstr(pi2a(mlang->sizeal));
    case REXMENU:
      maketitle(FALSE,"I N P U T:    R E G U L A R   E X P R E S S I O N S");
      mvaddstr(NAMROW,NAMCOL,"Name of the language: ");
      mvaddstr(REFROW,REFCOL,"Reference: ");
      mvaddstr(ALPROW,ALPCOL,"Size of the Alphabet: ");
      mvaddstr(ALPROW+1,ALPCOL,"Call the letters    : ");
      showtime = FALSE;
      break;
    case VERSMENU:
      mvaddstr(NAMROW,NAMCOL,"A M O R E");
      mvaddstr(NAMROW+2,NAMCOL,VERSION);
      mvaddstr(NAMROW+8,NAMCOL,"press any key to continue");
      mvaddstr(NAMROW+10,NAMCOL," ");
      refresh();
      getch();
      break;
    default: /* this should not happen */
      errex(SWERR,"DRAWMENU");
    } /* end switch */
  
  if ((showtime) && (comptime)) 
    {
      mess("Time used for the last computation (in millisecs): ");
      (void)sprintf(dummy,"%lu",comptime); 
      addstr(dummy); 
      inputpos;
      comptime = 0;
#ifdef OPT
      if (TRUE);  /* refresh() too fast (over optimized?) */
#endif
    }
  refresh();
} /* drawmenu */

/******************************************************************/
void inpmenu(menuno,flag)
     char menuno;
     boolx flag;
     /* fill windows with flag option (TRUE iff input)
      * NO RETURN
      */
{ 	
  switch(menuno) 
    {
    case TESTMENU:
      fillbox(OWIN,flag);
      fillbox(TWIN,flag);
      fillbox(LANG,flag);
      fillbox(LWIN,flag);
      break;
    case LANGMENU:
      fillbox(EWIN,flag);
      fillbox(MWIN,flag);
      fillbox(AWIN,flag);
      fillbox(LWIN,flag);
      fillbox(LANG,flag);
      break;
    case ASSIGNMENU:
      if ( una2operations == FALSE )    /* --- Bordeaux : 1995 --- */
	fillbox(UWIN,flag);             /* --- Bordeaux : 1995 --- */
      else                              /* --- Bordeaux : 1995 --- */
	fillbox(U2WIN,flag);            /* --- Bordeaux : 1995 --- */

      fillbox(BWIN,flag);
      fillbox(LWIN,flag);
      fillbox(LANG,flag);
      break;
    default: /* this should not happen */
      errex(SWERR,"inpmenu");
    }
  if (!flag) 
    help(FALSE,"Enter uppercase letter and number");
} /* inpmenu */

/******************************************************************/
void
updatewin(win)
     char win;
{	
  switch(menu) 
    {
    case TESTMENU:	
      switch(win) 
	{
	case AWIN: /* for modify */
	case OWIN:
	case TWIN:
	case LWIN:
	case LANG: 
	  fillbox(win,FALSE);
	  break;
	default  : 
	  errex(SWERR,"updatewin");
	}
      break;
    case LANGMENU:
      switch(win) 
	{
	case EWIN:
	case MWIN:
	case AWIN:
	case LWIN:
	case LANG: 
	  fillbox(win,FALSE);
	  break;
	default  :
	  errex(SWERR,"updatewin");
	}
      break;
    case ASSIGNMENU:
      switch(win) 
	{
	case AWIN: /* for modify */
	case UWIN:
	case BWIN:
	case U2WIN:/* --- Bordeaux : 1995 --- */
	case LWIN:
	case LANG: 
	  fillbox(win,FALSE);
	  break;
	default  : 
	  errex(SWERR,"updatewin");
	}
      break;
    default:
      errex(SWERR,"updatewin");
    }
  inputpos; refresh();
} /* updatewin */










