/* mtypes.h  3.0 (Kiel) 11.94    */

/* Memory management - fetching memory for objects. */
#define newcover(A,B)        { A = (cover) newbuf(1,sizeof(struct cov)); \
                             newgridlist(A->glist,B); }
#define newgridlist(A,B)     { A = (gridlist) newbuf(1,sizeof(struct gl)); \
                             newgrid(A->info,B); }             
#define newgrid(A,B)         { A = (grid) newbuf(1,sizeof(struct gr)); \
                             A->col = (char *)newbuf(B,sizeof(char)); }
#define newmdelta(A)       (ptset**)newbuf((posint)(A),sizeof(ptset*)); 
/* Memory for delta of fundamental table. */
#define newgsarray(A)      (ptset*)newbuf((posint)(A),sizeof(ptset));    
/* Memory for array of ptset's. */
#define newpattern(A,B)    { (A) = (ptset)newbuf(1,sizeof(struct set)); \
                           (A)->grset = (char *)newbuf(B,sizeof(char)); }
#define new_termlist(A)     { A = (termlist) newbuf(1,sizeof(struct tl));}             
#define new_term(A)         { A = (term) newbuf(1,sizeof(struct te)); \
                           A->set = (char *)newbuf(1,nbr); }
                                                      
/* Altering sets and testing of relationships.
 * add(A,B)                 element A is joined to set B. 
 * sub(A,B)                 element A is deleted from set B.
 * Testelem(A,B)    iff     A is element of set B.
 */
#define add(A,B)	     { ai = A / SIZEOFBYTE; am = 0x1 << (A % SIZEOFBYTE); \
                                     if (!((B)[ai] & am)) (B)[ai] += am; }
#define sub(A,B)	     { ai = A / SIZEOFBYTE; am = 0x1 << (A % SIZEOFBYTE); \
           			     if ((B)[ai] & am) (B)[ai] -= am; }
#define testelem(A,B)        ((B)[A / SIZEOFBYTE] & (0x1 << (A % SIZEOFBYTE)))

/* Typedefs. */

typedef char* bitmap;          /* Bitmaps are used for sets. */

typedef struct set
       { bitmap grset;       
         posint ngrset;      
       }* ptset;                       

/* The number of elements of set grset is ngrset.  */

typedef struct gr
       {  bitmap col;       
          posint ncol;      
       }* grid;                    

/* col is the set of columns in the grid 
 * ncol is the number of columns of grid j.
 */

typedef struct gl
       {  grid       info;
          struct gl* next;
       }* gridlist;

/* Gridlists are used for defining lists of grids. Each 
 * element has a component named info which is a grid and a
 * pointer to the next gridlist.
 */

typedef struct cov
       {  gridlist glist;
          posint   sizeofglist;
       }* cover;           

/* A cover has a component for the number of grids and a 
 * pointer to the first element of the list of grids.
 */

typedef struct te
       {  bitmap set;
          posint nset,k;
       }* term;                 

/* Terms are used for boolean sums. The set is used for      
 * representing the uncomplemented variables. Their number
 * is nset. Only one complemented variable is allowed; this
 * can be stored in the posint k.
 */

typedef struct tl
       {  array      info;
          posint     nv;
          struct tl* next;
          struct tl* bef;
       }* termlist;

/* Termlists are used for defining lists of terms. Each     
 * element has a component named info which is an array.   
 * This array is used for storing the numbers of the      
 * variables of the term. The component named nv is a posint
 * used for storing the number of the variables. A termlist
 * also has a pointer each to the termlist before and after
 * it.                                                       
 */
