/* print.c 3.0 (KIEL) 11.94 */

#include "ext.h"

/* functions included
 *
 *	void printrex
 *	void printdaut
 *	void printmon
 *	void printmult
 *	void printdclass
 *      void printsfx()
 */

/******************************************************************/
/******************************************************************/
void
printrex(flag)
boole flag; /* TRUE iff print reg.expr. (else print gen.reg.expr.) */
{
 if(!curlan->brex || (flag && curlan->lrex->grex))
    comprex();	
	if (flag)   /* reg.exp */
            {
	     (void)startprint(curlan->name,curlan->ref,".rex");
	     if (curlan->inputis != OREXINP) 
		     prtrex(curlan->lrex,flag);
             else
                if(curlan->orex->grex) 
		     prtrex(curlan->lrex,flag);
                else
		     prtrex(curlan->orex,flag);
           }
	else    
           {
            (void)startprint(curlan->name,curlan->ref,".grx");
	    if (curlan->inputis == OREXINP) 
		prtrex(curlan->orex,flag);
	    else 
                prtrex(curlan->lrex,flag); 
             /* either lrex is a generalized expr. or
                no generalized expression exists */
	   } 
	(void)endprint();
} /* printrex */

/******************************************************************/
void
printdaut(flag)
boole flag;
{
	if (flag) compmdfa();
	else compdfa();

	if (flag) (void)startprint(curlan->name,curlan->ref,".mfa");
	else	  (void)startprint(curlan->name,curlan->ref,".dfa");

	if (curlan->inputis == ODFAINP) {
		if (flag) prtdaut(curlan->ldfa);
		else      prtdaut(curlan->odfa);
	} else prtdaut(curlan->ldfa);
	(void)endprint();
} /* printdaut */

/******************************************************************/
void
printnaut(flag)
boolx flag;
{
 /* flag == TRUE epsilon-automaton
  *      == FALSE original-nfa or minimal nfa
  *      == UN_KNOWN minimal nfa
  */
  switch(flag){
        case TRUE   : (void)startprint(curlan->name,curlan->ref,".efa");
                      if (curlan->inputis == OENFAINP) prtnaut(curlan->oenfa);
		      else 
                        if (curlan->inputis == ONFAINP) prtnaut(curlan->onfa);
                        else { compnfa(); prtnaut(curlan->lnfa); }
                      break;
        case FALSE  : compnfa();
	              (void)startprint(curlan->name,curlan->ref,".nfa");
                      if (curlan->inputis == ONFAINP) prtnaut(curlan->onfa);
		      else prtnaut(curlan->lnfa);
                      break;
        case UN_KNOWN : compmnfa();
	              (void)startprint(curlan->name,curlan->ref,".mna");
                      prtnaut(curlan->lnfa);
                      break;
        default :     ; /* wrong choice, do nothing */
        }
	(void)endprint();
} /* printnaut */

/******************************************************************/
void 
printmon()
{       compmon();
	(void)startprint(curlan->name,curlan->ref,".mon");
	prtmon(curlan->lmon,FALSE);
	(void)endprint();
        if(!curlan->lmon->relationcomputed)
           mon2rel(curlan->lmon);
	(void)startprint(curlan->name,curlan->ref,".rel");
	prtrel(curlan->lmon);
	(void)endprint();
} /* printmon */

/******************************************************************/
void 
printdclass()
{	compdclass();

	(void)startprint(curlan->name,curlan->ref,".dcl");
	prtdcl(curlan->lmon);
	(void)endprint();
} /* printdclass */
/******************************************************************/
void 
printmult()
{       compmon();
	(void)startprint(curlan->name,curlan->ref,".mul");
	multtable(curlan->lmon,TRUE);
	(void)endprint();
} /* printmult */
/******************************************************************/
void
printsfx()
/* tests and prints a starfree expression from curlan */
{
	compsfx();
	if (curlan->starfree) {	/* yes */
	        (void)startprint(curlan->name,curlan->ref,".sfx");
                help(FALSE,"The marked language is starfree.");
		editsfx(curlan->ldfa,curlan->lmon,curlan->sexp,FALSE,TRUE);
	        (void)endprint();
		drawmenu(menu=LANGMENU);
	} else 	{		/* no */
		help(TRUE,"The marked language is not starfree. Press a key to confirm.");
	}
} /* printsfx */
