/* prtcomp.c 3.0 (KIEL) 11.94 */

#include "ext.h"

/* functions included:
 *
 *	static void printstr()
 *	       void prtrex()
 *	static posint dautpage()
 *	static posint dautline()
 *	       void prtdaut()
 *	static posint nautpage()
 *	static posint nautline()
 *	       void prtnaut()
 *	static posint monpage()
 *	static posint monline()
 *	       void prtmon()
 */

#define nmax	4
#define newlelem(A)  {A = (lentry)newbuf(1,sizeof(struct lelem));}

#define COLOFFSET	5
#define XOFFSET		2


static boole alph;
static dfa da;
static int coljump, colpage;
static nfa na;
static posint na_qno;

static posint startpage;
static int startcol;
static monoid mon;
static char **linestr,**oldlinestr;
static posint *length;
static boole table;

typedef struct lelem
	{ posint state,letter;
	  struct lelem *next;
} *lentry;

static lentry first,last;

/******************************************************************/
static void
printstr(str,strl,row,col)
string str;
posint strl;
int *row;
int col;
{ char ch;
  int pcolscol = pcols-col-1;
	while (strl > pcolscol) {
		strl -= pcolscol;
		ch = str[pcolscol]; str[pcolscol] = '\0';
		pgmvaddstr((*row)++,col,str);
		str[pcolscol] = ch;
		str += pcolscol;
		if (getpgrow() == plines) {
			pgbreak();
			govertical();
			*row = 1;
		}
	}
	if (strl) pgmvaddstr((*row)++,col,str);
} /* printstr */

/******************************************************************/
void
prtrex(re,flag)
regex re;
boole flag;
{ int i;
  int row = 1;
	pgmvaddstr(row,COLOFFSET,"D E F I N I T I O N S");
	for(i = -1; ++i <= re->useda;) {
		row++;
		pgmvaddch(row,COLOFFSET,'A'+i); pgaddstr(": ");
		printstr(re->abbr[i],re->abbl[i],&row,COLOFFSET+4);
	}
	row +=2;
	if (flag)
	  pgmvaddstr(row++,COLOFFSET,"R E G U L A R   E X P R E S S I O N");
	else
	  pgmvaddstr(row++,COLOFFSET,"G E N.  R E G U L A R   E X P R E S S I O N");
	printstr(re->rex,re->rexl,&row,COLOFFSET);
	if (row != 1) pgbreak();
} /* prtrex */


/******************************************************************/
static posint
dautpage(state,stateend,fstletter,colpos,x)
posint state,stateend,fstletter;
int colpos,x;
{ int row = x,c;
  posint col, colend;
	if (fstletter + colpage - (colpos/coljump) - 1 > da->sno)
		colend = da->sno + 1;
	else    colend = fstletter + colpage -  (colpos/coljump);

	/* line with the alphabet */
	if (!state) {
	  row--;
	  for(col=fstletter,c=colpos; col<colend; c+=coljump,col++)
		if (alph) pgmvaddch(row,c,itoc[col]);
		else {    pgmvaddch(row,c,'a');
			  pgmvaddstr(row,c+1,pi2a(col));
		}
	  row++;
	}

	/* now the states */
	for(;state < stateend; row++, state++)
	   for(col = fstletter,c = colpos; col < colend; c += coljump) {
		pgmvaddch(row,c,'q');
		pgmvaddstr(row,c+1,pi2a(da->delta[col++][state]));
	   }

	return col;
} /* dautpage */

/******************************************************************/
static posint
dautline(s,x)
posint s;
int x;
{ int colpos = COLOFFSET;
  int row = x;
  posint state, stateend, fstletter = 1;
	if (s + plines -x > da->qno)
		stateend = da->qno + 1;
	else	stateend = s + plines - x;

	for(state = s; state < stateend; row++, state++) {
		if (state == da->init) pgmvaddch(row,colpos-1,'*');
		pgmvaddch(row,colpos,(da->final[state])? 'Q':'q');
		pgmvaddstr(row,colpos+1,pi2a(state));
	}
	fstletter = dautpage(s,stateend,fstletter,colpos+coljump,x);
	pgbreak(); gohorizontal();
	while (fstletter <= da->sno) {
		fstletter = dautpage(s,stateend,fstletter,colpos,x);
		pgbreak(); gohorizontal();
	}

	return state;
} /* dautline */

/******************************************************************/
void
prtdaut(d)
dfa d;
{ posint state;
	da = d;
	coljump = strlen(pi2a(da->qno)) + 3;
	colpage = (pcols-COLOFFSET-1) / coljump;
	alph = (da->sno <= ALPHSIZE);

	if (da->minimal)
	   pgmvaddstr(1,COLOFFSET,"M I N.  D F A   T R A N S I T I O N T A B L E");
	else pgmvaddstr(1,COLOFFSET,"D F A   T R A N S I T I O N T A B L E");

	state = dautline(0,3);
	govertical();
	while (state <= da->qno) {
		state = dautline(state,1);
		govertical();
	}
} /* prtdaut */

/******************************************************************/
static posint
nautpage(state,stateend,fstletter,colpos,x)
posint state,stateend,fstletter;
int colpos,x;
{ int row = x,c;
  posint col, colend;
  int ncount;
  posint goal;
  lentry hlp;
	if (fstletter + colpage - (colpos/coljump) - 1 > na->sno)
		colend = na->sno + 1;
	else    colend = fstletter + colpage - (colpos/coljump);

	/* line with the alphabet */
	if (!state) {
	  row--;
	  for(col=fstletter,c=colpos; col<colend; c+=coljump,col++)
		if (alph) pgmvaddch(row,c,itoc[col]);
		else {    pgmvaddch(row,c,'a');
			  pgmvaddstr(row,c+1,pi2a(col));
		}
	  row++;
	}

	/* now the states */
	for(;state < stateend; row++, state++)
	   for(col = fstletter,c = colpos; col < colend; col++, c += coljump) {
	      ncount = 0; pgmove(row,c);
	      for(goal=0; goal <= na_qno; goal++)
		if (testcon(na->delta,col,state,goal)) {
			if (ncount) pgaddch(',');
			if (++ncount == nmax) {
			   pgaddch('*');
			   newlelem(hlp);
			   hlp->state = state;
			   hlp->letter = col;
			   hlp->next = NULL;
			   last->next = hlp;
			   last = hlp;
			   break;
			} else {
			   pgaddch('q');
			   pgaddstr(pi2a(goal));
			}
		}
	   }

	return col;
} /* nautpage */

/******************************************************************/
static posint
nautline(s,x)
posint s;
int x;
{ int colpos = COLOFFSET;
  int row = x;
  posint state, stateend, fstletter = 1;
	if (s + plines -x > na_qno)
		stateend = na_qno + 1;
	else	stateend = s + plines - x;

	for(state = s; state < stateend; row++, state++) {
		if (isinit(na->infin[state])) pgmvaddch(row,colpos-1,'*');
		pgmvaddch(row,colpos,(isfinal(na->infin[state]))? 'Q':'q');
		pgmvaddstr(row,colpos+1,pi2a(state));
	}
	fstletter = nautpage(s,stateend,fstletter,colpos+coljump,x);
	pgbreak(); gohorizontal();
	while (fstletter <= na->sno) {
		fstletter = nautpage(s,stateend,fstletter,colpos,x);
		pgbreak(); gohorizontal();
	}

	return state;
} /* nautline */

/******************************************************************/
void
prtnaut(n)
nfa n;
{ posint state,goal;
  int row,col,startcol;
	na = n;
	na_qno = na->qno;
	coljump = (strlen(pi2a(na_qno))+2)*nmax + 2;
	colpage = (pcols-COLOFFSET-1) / coljump;
	alph = (na->sno <= ALPHSIZE);
	newlelem(first);
	last = first;

	pgmvaddstr(1,COLOFFSET,"N F A   T R A N S I T I O N T A B L E");

	state = nautline(0,3);
	govertical();
	while (state <= na_qno) {
		state = nautline(state,1);
		govertical();
	}

	if (first->next != NULL) {
		first = first->next;
		row = 1;
		pgmvaddstr(row++,COLOFFSET,"L I S T   O F   * - T R A N S I T I O N S");

		while (first != NULL) {
	      	    pgmvaddch(row,COLOFFSET,'('); pgaddch('q');
		    pgaddstr(pi2a(first->state)); pgaddch(',');
		    if (alph) pgaddch(itoc[first->letter]);
		    else { pgaddch('a'); pgaddstr(pi2a(first->letter));}
		    pgaddstr("): ");
		    pggetyx(&row,&startcol);
	      	    for(goal=0; goal <= na_qno; goal++)
			if (testcon(na->delta,first->letter,first->state,goal)) {
			   pgaddch('q'); pgaddstr(pi2a(goal)); pgaddch(' ');
			   pggetyx(&row,&col);
			   if (col > pcols-8) {
				if (row++ != plines-2) pgmove(row,startcol);
				else { pgbreak(); govertical();
				       row = 1; pgmove(row,startcol);
				}
			}  }
		    first = first->next; row += 2;
		    if ((row >= plines-3) && (first != NULL)) {
			pgbreak(); govertical(); row = 1;
		    }
		}
		pgbreak();
	}
	freebuf();
} /* prtnaut */


/******************************************************************/
static posint
monpage(elem,elemend,fststate,colpos,x)
posint elem, elemend, fststate;
int colpos,x;
{ int row = x,c;
  posint col, colend;
	if (fststate + colpage - (colpos/coljump) - 1 > mon->qno)
		colend = mon->qno + 1;
	else	colend = fststate + colpage - (colpos/coljump);

	if (!elem) {
		row--;
		col = fststate;
		c = colpos;
		if(table) { /* skip first entry */
			col++;
			c += coljump;
		}
		for(; col<colend; c+=coljump,col++)
			pgmvaddstr(row,c,pi2a(col));
		row++;
	}

	for(;elem < elemend; row++, elem++)
		for(col = fststate,c = colpos; col < colend; c += coljump)
			pgmvaddstr(row,c,pi2a(mon->no2trans[elem][col++]));

	return col;
} /* monpage */


/******************************************************************/
static posint
monline(e,x)
posint e;
int x;
{ boole nextpg;
  posint elem, elemend, fststate = 0;
  int i,row = x, hpgno, diff,colpos = COLOFFSET;
  char ch;
	if (e + plines - x -1 > mon->mno)
		elemend = mon->mno;
	else    elemend = e + plines - x - 1;

	linestr = oldlinestr;

	for(i = x, elem = e; elem < elemend; i++, elem++)
		(void)prword1(&linestr[i],TRUE,&length[i],elem,mon,TRUE,TRUE);

	diff = pcols - colpos - 1;
	i = x; hpgno = 0;
	nextpg = TRUE;

	while (nextpg) {
	   nextpg = FALSE;
	   for(row = x, elem = e; elem < elemend; row++, elem++) {
		if (length[i] > diff) {
			ch = linestr[i][diff];
			linestr[i][diff] = '\0';
			pgmvaddstr(row,colpos,linestr[i]);
			linestr[i][diff] = ch;
			linestr[i] += diff;
			length[i] -= diff;
			nextpg = TRUE;
		} else if (length[i]) {
			pgmvaddstr(row,colpos,linestr[i]);
			length[i] = 0;
		       }
		
		i++;
	   }
	   if (nextpg) {
	   	pgbreak(); gohorizontal(); hpgno++;
	   	i = x;
	   	diff = pcols-1; colpos = 0;
	   }
	}

	if (++hpgno < startpage) {
		pgbreak();
		gohorizontal();
	}
	while (++hpgno < startpage) gohorizontal();

	fststate = monpage(e,elemend,fststate,startcol,x);
	pgbreak(); gohorizontal();
	while (fststate <= mon->qno) {
		fststate = monpage(e,elemend,fststate,XOFFSET,x);
		pgbreak(); gohorizontal();
	}

	return elem;
} /* monline */


/******************************************************************/
void
prtmon(m,tab)
monoid m;
boole tab;   /* TRUE iff multiplication table */
{ posint elem;
	mon = m;
	table=tab;
	if (table) coljump = strlen(pi2a(mon->mno)) + 2;
	else       coljump = strlen(pi2a(mon->qno)) + 2;
	colpage = (pcols-1-COLOFFSET) / coljump;

        startpage = (mon->sno > ALPHSIZE)? monmaxlen(mon):mon->no2length[mon->mno-1];
        startpage+=COLOFFSET;
	startcol = (startpage % (pcols-1)) + 2;
	startpage /= (pcols-1);
	startcol += (startpage*XOFFSET);
	if (startcol > pcols-1) {
		startcol -= (pcols - 1 + XOFFSET);
		startpage++;
	}
	startpage++;

	linestr = newarrayofstring(plines);
	oldlinestr = linestr;
	length = newarray(plines);

	if (table) pgmvaddstr(1,COLOFFSET,"M U L T I P L I C A T I O N   T A B L E");
	else       pgmvaddstr(1,COLOFFSET,"S Y N T A C T I C   M O N O I D");

	elem = monline(0,3);
	govertical();
	while (elem < mon->mno) {
		elem = monline(elem,1);
		govertical();
	}
	freebuf();
} /* prtmon */
