/* prtdcl.c 3.0 (KIEL) 11.94 */

#include "ext.h"

/* print procedures
 * static void alistinit()
 * static void alistinsert()
 * static void printprimdclass()
 * static void prline()
 * static void primage()
 * static void prkernel()
 * static void prtask()    print part of dclass 
 * static boole taskcompare()
 * static void ordertask()
 * static void computetasks()
 *        void prtdcl()
 * structure of alist task
 *    0. pagevertical
 *    1. pagehorizontal 
 *    2. dclassnumber 
 *    3. startrow 
 *    4. begincol
 *    5. rstart    first rclass on page 
 *    6. rmax      number of  rclasses on page
 *    7. lstart    first lclass on page 
 *    8. lmax      number of lclasses on page
 *    9. hstart    first element of hclass on page 
 *    10.hmax      number of elements on page
 *    11.boxsize
 */

#define newalist()		(alist)newbuf((posint)1,(posint)sizeof(struct listarray))
typedef struct listarray{array info;
			  struct listarray *next;
			 }*alist;

static void alistinit(ptfirst,ptlast,a)
alist *ptfirst,*ptlast;
array a;
{*ptfirst=newalist();
(*ptfirst)->info=a;
(*ptfirst)->next=NULL;
 *ptlast= *ptfirst;
}

/******************************************************************/
static void alistinsert(ptlast,a)
alist* ptlast;
array a;
{(*ptlast)->next=newalist();
  *ptlast=(*ptlast)->next;
 (*ptlast)->next=NULL;
 (*ptlast)->info=a;
}
/******************************************************************/
/* static variables for the output of dclasses */
static monoid stamon;
static int immaxsize;
static int row;
static boole  image;
static alist task,wtask;

static posint actrang;

/******************************************************************/
/******************************************************************/
/******************************************************************/


# define STARTKERNEL 2

/******************************************************************/
static void printprimdclass()
{
 darray d=stamon->ds->dclassarray; /* abbreviation */
 posint drun,dno;
 int colco,count;
 drun=0;
 pgmvaddstr(1,5,"G L O B A L  S T R U C T U R E  O F  G R E E N ' S  R E L A T I O N S");
 pgmvaddstr(3,32,"R-classes  L-classes  Elements per H-class");
 count=4;
 while(drun!=stamon->ds->dno)
    {
     if(count==(plines-1))
       {pgbreak();govertical();count=3;}
     else 
       count++;
     dno=drun+1;
     while((dno<stamon->ds->dno)&&dcomp(stamon,dno,drun))dno++;
     colco=1; pgmvaddstr(count,colco,pi2a(dno-drun)); 
     colco += 3;
     if(d[drun]->regular) pgmvaddstr(count,colco,"reg.   ");
     else pgmvaddstr(count,colco,"irreg. ");
     if((dno-drun)>1) pgaddstr("D-classes rank ");
     else pgaddstr("D-class   rank ");
     pgaddstr(pi2a(d[drun]->rang));
     colco += 24; pgmvaddstr(count,colco," : ");
     colco += 8;  pgmvaddstr(count,colco,pi2a(d[drun]->rno));
     colco += 11; pgmvaddstr(count,colco,pi2a(d[drun]->lno));
     colco += 15; pgmvaddstr(count,colco,pi2a(d[drun]->hsize));
     drun=dno;
     }
 pgbreak();
}

/******************************************************************/
static void prline(col,length) 
/* print one line - in row row from columne col with length length */
 int col;
 posint length;
{
 posint i;
 pgmove(row,col);
 for(i=0;i<=length;i++) pgaddch('-');
}

/******************************************************************/
static void prkernel(no)
posint no;
{register posint l;
 array k=cpt_image_kernel(stamon,no,FALSE);
 pgmove(row,STARTKERNEL);
 for(l=0;l<actrang+stamon->qno;l++)
	if(k[l]==stamon->qno+1) pgaddch('/');
	else {pgaddch(' ');pgaddstr(pi2a(k[l]));}
}

/******************************************************************/
static void primage(no,c)
posint no;
int c;
{
 register posint l;
 array i= cpt_image_kernel(stamon,no,TRUE);
 pgmove(row,c);
 for(l=0;l<actrang;l++)
    {pgaddch(' ');
     pgaddstr(pi2a(i[l]));
    }
}

/******************************************************************/
static void prtask(a)
/* print part of dclass
 * hstart,rstart,lstart,hmax,rmax,lmax and
 * image,begincol,boxsize are used like in outdstruct
 * see comment on line 40 -..  
 * one difference
 *   if(lstart!=0) without image
 *   if(rstart!=0 or hstart!=0) without kernel
 */
array a;
{
 posint rcount;
 posint lno,rno,hno;
 posint help,help1;
 int begincol,boxsize,col;
 posint rstart,rmax,lstart,lmax,hstart,hmax;
 d_class dc;
 dc       = stamon->ds->dclassarray[a[2]];
 row      = a[3];
 begincol = a[4];
 rstart   = a[5];
 rmax     = a[6];
 lstart   = a[7];
 lmax     = a[8];
 hstart   = a[9];
 hmax     = a[10]; 
 boxsize  = a[11];
 actrang=dc->rang;
 pgmove(row,begincol);
 if(image&&(!rstart)&&(!hstart))
    /* with image and kernel first rclass and first element of rclass */
   {
    col = begincol+1; /* first usable column */
    for(lno=lstart;lno<lmax+lstart;col+=boxsize)
      primage(mult(stamon,dc->org,dc->lrep[lno++]),col);
    row++;
   }
 prline(begincol,lmax*boxsize);
 row++;
 rcount=(rmax)? rmax : 1; 
 for(rno=rstart;rno<rstart+rcount;rno++) 
  /* print rclasses rstart .. rstart+rcount-1 */
       {
        if(image&&(!hstart)&&(!lstart))
	   prkernel(mult(stamon,dc->rrep[rno],dc->org));
        for(hno=hstart;hno<hstart+hmax;hno++,row++)
           {
            help=mult(stamon,dc->rrep[rno],dc->hclass[hno]);
            col=begincol;
            for(lno=lstart;lno<lstart+lmax;lno++,col+=boxsize)
              {
               pgmvaddch(row,col,'|');
               help1=mult(stamon,help,dc->lrep[lno]);
               pgaddstr(prword(help1,stamon,TRUE));
              }
              pgmvaddch(row,col,'|');
           }
        prline(begincol,lmax*boxsize);
	row++;
       }
}

/******************************************************************/
static boole taskcompare(task1,task2)
/* TRUE iff task2 before task1 */
array task1,task2;
{
 posint i;
 for(i=0;i<4;i++)
  {
   if(task2[i]<task1[i])return(TRUE);
   if(task2[i]>task1[i])return(FALSE);
   }
 return(FALSE);
}
 
/******************************************************************/
static void ordertask(tasklist)
/* sort alist task or wtask depending on image
 * use bubblesort because list is nearly ordered 
 */
alist tasklist;
{
 alist run1,run2;
 array change;
 boole test=TRUE; /* mark change */
 while(test)
   {
    test=FALSE;
    run1=tasklist;
    run2=run1->next;
    while(run2!=NULL)
      {
       /* compare arrays */
       if(taskcompare(run1->info,run2->info)) /* change arrays */
	 {
	  test=TRUE;
	  change=run2->info;
	  run2->info=run1->info;
	  run1->info=change;
	 }
       run1=run2;
       run2=run2->next;
      }
   }
}

/******************************************************************/
static void computetasks()
{
 /* philosophie :
  *   start at new page if 
  *     dclass needs more lines than available and 
  *         a) only one rclass needs more lines than available or
  *         b) new dclass longer than the old one 
  * a dclass starts always at the left border
  * output format
  *   
  * size of a dclass : 
  *    rno * (hsize+1)+1  boxes
  *   +1                  free line between 2 dclasses
  *   +1                  image
  *
  * 
  *         image | image | image |
  *         ----------------------
  * kernel |      |       |       |
  *        |      |       |       |
  *        -----------------------
  * kernel |      |       |       |
  *        |      |       |       |
  *
  */
 darray d=stamon->ds->dclassarray; /* abbreviation */
 d_class dc;
 int hno,lno,rno;       /* first element/lclass/rclass on page */
 int h,l,r;             /* last element/lclass/rclass on page */
 int hhelp,lhelp,rhelp; /* number of elements/lclasses/rclasses on the first page */
 int lhelp1,rhelp1;     /* number of lclasses/rclasses on the following pages */
 int help; 
 int firstrow=1;
 int actrow=1; /* actuel row */
 int remain; /* free lines on page */
 int pgrowcount = 0; /* depth in pages  */
 int pgcolcount = 0;  
 int dcrow; /* size of dclass dc n rows */ 
 int dccolpage1 = 0,dccolpage2; /* length of actuel,previous dclass in pages */
 int begincol = 2; /* start of first box , if(!image) begincol = 2 */
 int boxsize;  /* size of a box */
 int imsize;   /* size of a image */
 posint taskcount=0;
 posint dcount;
 array  atask; /* new task */
 alist first,last;
 for(dcount=0;dcount<stamon->ds->dno;dcount++) /* for all dclasses */
   {
    /* copy length of previous dclass */
    dccolpage2 = dccolpage1;
    /* make dc the current dclass */
    dc = d[dcount];
    /* compute new sizes */
    boxsize = dc->maxlen+3;
    dcrow=dc->rno*(dc->hsize+1)+2; 
    if(image)
	{
         begincol = STARTKERNEL+immaxsize+dc->rang-1;
	 imsize = imsizecompute(stamon,dc->rang);
         boxsize = ((imsize+1)>boxsize)? imsize+1 : boxsize;
	 dcrow++;
	}
    /* compute number of pages in horizontal direction */
    lhelp=(pcols-(begincol+2))/boxsize; /* number of lclasses on first page */
    dccolpage1=1;
    if(lhelp<dc->lno) /* more than one page in horizontal direction */
      {
       lhelp1 = (pcols-3)/boxsize; /* number of lclasses on next pages */
       help = dc->lno - lhelp;
       dccolpage1 += (help/lhelp1);
       if(help%lhelp1) dccolpage1++;
      }
    else
       lhelp = dc->lno;

    /* compute first line for dclass */

    remain = plines-(actrow+2); /* number of lines available */
    if(actrow != firstrow) /* if not on first line */
        if(dcrow > remain) 
           /* dclass needs more lines than available
            * decide whether to start on a new page in vertical direction
	    * if one rclass needs more lines than available or
	    *    new dclass is much longer than the previous one or
	    *    there ar eonly few remaining lines
	    * then start on new page   
	    */
	   if(( remain < dc->hsize+4 ) || (( dccolpage1 > 2*dccolpage2 ) && dcount)||(remain<10))
	     {
	      actrow=firstrow;
	      remain=plines-(actrow+1);
	      pgrowcount++;
             }

    /* actrow and dcrowpage define the beginning of the dclass 
     * now compute all tasks of this dclass
     * 1. case   less than one rclass on one page
     * 2. case   at least one rclass on one page 
     */

    if( plines - 6 < dc->hsize )
         /* less than one rclass on one page
          * in this case actrow = firstrow
	  * start each rclass on a new page 
          */
       {
	hhelp = plines - 4;  /* number of elements on one page */
        for(rno=0;rno<dc->rno;rno++)
            for(hno=0;hno<dc->hsize;) 
	      {
	       h = ( hno+hhelp > dc->hsize)? dc->hsize : (hno+hhelp);
	       pgcolcount=0;
	       for(lno=0;lno<dc->lno;)
	         {
	          if(lno)
		     l = ( lno+lhelp1 >dc->lno)? dc->lno : lno+lhelp1;
                  else
		     l = ( lhelp > dc->lno)? dc->lno : lhelp;
                  atask=newarray(12);
 	          atask[0] = pgrowcount;
	          atask[1] = pgcolcount++;
	          atask[2] = dcount;
	          atask[3] = firstrow;
	          atask[4] = (lno)? 2 : begincol;
	          atask[5] = rno;
	          atask[6] = 0;
	          atask[7] = lno;
                  atask[8] = l-lno;
	          atask[9]  = hno;
		  atask[10] = h-hno;
		  atask[11] = boxsize;
	          if(taskcount)alistinsert(&last,atask);
	          else         alistinit(&first,&last,atask);
	          taskcount++;
		  lno=l;
		 }
	       if((h==dc->hsize)&&(rno==(dc->rno-1)))
	           actrow = firstrow+4+h-hno;
	       else
		  pgrowcount++;
               hno = h;
              }
       }
    else
       {    
        /* compute number of rclasses on the first page and the next pages */
        rhelp = (remain-2) / (dc->hsize+1); /* number of rclasses on first page */
        if(rhelp<dc->rno) /* more than one page */
           rhelp1 = (plines-4) / (dc->hsize+1);
        for(rno=0;rno<dc->rno;) 
	    {
	     pgcolcount = 0;
	     if(rno)
		r = ( rno+rhelp1 >dc->rno)? dc->rno : rno+rhelp1;
             else
		r = ( rhelp > dc->rno)? dc->rno : rhelp;
	     for(lno=0;lno<dc->lno;)
	         {
	          if(lno)
		     l = ( lno+lhelp1 >dc->lno)? dc->lno : lno+lhelp1;
                  else
		     l = ( lhelp > dc->lno)? dc->lno : lhelp;
                  atask=newarray(12);
 	          atask[0]  = pgrowcount;
	          atask[1]  = pgcolcount++;
	          atask[2]  = dcount;
	          atask[3]  = (rno)? firstrow : actrow; 
	          atask[4]  = (lno)? 2 : begincol;
	          atask[5]  = rno;
	          atask[6]  = r-rno;
	          atask[7]  = lno;
                  atask[8]  = l-lno;
	          atask[9]  = 0;
	          atask[10] = dc->hsize;
		  atask[11] = boxsize;
	          if(taskcount)alistinsert(&last,atask);
	          else         alistinit(&first,&last,atask);
	          taskcount++;
		  lno = l;
		 } 
	     if(r < dc->rno) pgrowcount++;
	     else
		if(rno)
	            actrow = firstrow+(dc->hsize+1)*(r-rno)+2;
                else 
		    actrow += (dc->hsize+1)*(r-rno)+2;
                if(image)actrow++;
	     rno=r;
	   }
     }
   }
 if(image) wtask=first; else task=first;
}

/******************************************************************/
void prtdcl(mon)
monoid mon;
{
 posint lasthor=0;
 posint lastver=0;
 posint dcount;
 int kersize,imsize,boxsize,max;
 d_class dc;
 alist tasklist;
 array a; 
 stamon=mon; 
 max=(stamon->sno<=ALPHSIZE)? 1 : (1+strlen(pi2a(stamon->sno)));
 printprimdclass(); 
 if((stamon->no2length[stamon->mno-1]*max+3)>pcols) return;
 immaxsize=computesizeofstates(stamon->qno);
 /* if for one dclass the kernel and the boxsize is longer than one line image=FALSE */
 max=0;
 image=TRUE;
 for(dcount=0;dcount<stamon->ds->dno;dcount++) /* for all dclasses */
   {
    dc = stamon->ds->dclassarray[dcount];
    kersize = STARTKERNEL+immaxsize+dc->rang-1; /* length of kernel */
    imsize = imsizecompute(stamon,dc->rang);  /* length of image */
    boxsize = dc->maxlen+3;
    boxsize = ((imsize+2)>boxsize)? imsize+2 : boxsize;
    boxsize += kersize;
    if(max<boxsize) max=boxsize;
    if(max>=pcols) 
      { image=FALSE; break; }
   }
 /* compute tasks for output */
 computetasks();
 /* ask user whether output with/without image and kernel */
 tasklist=(image)? wtask : task;
 ordertask(tasklist);
 /* only if output with image and kernel */
 if(image)initarray(stamon);
 /* output using tasklist */
 while(tasklist!=NULL)
   {
    a=tasklist->info;
    /* actualize lasthor,lastver and change page if neccessary */
    if(a[0]!=lastver)
      {lastver=a[0];lasthor=0;pgbreak();govertical();}
    else
      if(a[1]!=lasthor)
	{lasthor++;pgbreak(); gohorizontal();}
    prtask(a);
    tasklist=tasklist->next;
   }
 pgbreak(); /* last page */
 freebuf();
}
