/* show.c 3.0 (KIEL) 11.94 */

#include "ext.h"

/* functions included
 *
 *	void showdfa
 *	void showmdfa
 *	void showeps
 *	void shownfa
 *      void showmnfa
 *	void showregx
 *	void showgenregx
 *	void showmon
 *	void showdclasses
 *	void showmult
 *	void showsfx
 */

static boole ***dumnbuf = NULL;
static posint **dumdbuf = NULL;

/******************************************************************/
/******************************************************************/
void
showdfa()
/* shows the DFA */
{ dfa w;
	compdfa();
	if (curlan->inputis == ODFAINP) w = curlan->odfa;
	else w = curlan->ldfa;
	(void)edit(w->delta,dumnbuf,w->final,w->qno,w->sno,1,w->init,TRUE,FALSE);
	drawmenu(menu);
} /* showdfa */

/******************************************************************/
void
showmdfa()
/* shows the minimal DFA */
{ dfa w;
	compmdfa();
	w = curlan->ldfa;
	(void)edit(w->delta,dumnbuf,w->final,w->qno,w->sno,1,w->init,TRUE,FALSE);
	drawmenu(menu);
} /* showmdfa */

/******************************************************************/
void
shownfa()
/* shows the NFA */
{ nfa w;

	compnfa();
	if (curlan->inputis == ONFAINP) w = curlan->onfa;
	else w = curlan->lnfa;
	(void)edit(dumdbuf,w->delta,w->infin,w->qno,w->sno,1,0,TRUE,TRUE);
	drawmenu(menu);
} /* shownfa */

/******************************************************************/
void
showmnfa()
/* shows the NFA */
{ nfa w;
  
        compmnfa();
        w = curlan->lnfa; 
        (void)edit(dumdbuf,w->delta,w->infin,w->qno,w->sno,1,0,TRUE,TRUE);
        drawmenu(menu);
} /* showmnfa */

/******************************************************************/
void
showregx()
/* shows a regular expression */
{ 	comprex();
	edrex(curlan->lrex,FALSE);
	drawmenu(menu);
} /* showregx */

/******************************************************************/
void
showgenregx()
/* show a generalized regular expression */
{ regex w;
	if (curlan->inputis == OREXINP) w = curlan->orex;
	else { if (curlan->inputis != REXINP) comprex(); w = curlan->lrex; }
	edrex(w,FALSE);
	drawmenu(menu);
} /* showgenregx */

/******************************************************************/
void
showeps()
/* shows the epsilon automaton */
{ nfa w;
  posint i=1;
	if(curlan->inputis == OENFAINP) w = curlan->oenfa;
	else if(curlan->inputis == ONFAINP) w = curlan->onfa;
        else
           {compnfa();
            w = curlan->lnfa;
           }
	if(w->is_eps) i=0;
	(void)edit(dumdbuf,w->delta,w->infin,w->qno,w->sno,i,0,TRUE,TRUE);
	drawmenu(menu);
} /* showeps */

/******************************************************************/
void 
showmon()
/* shows the monoid */
{ 
  compmon();
  editmon(curlan->lmon,FALSE);
  drawmenu(menu);
} /* showmon */ 

/******************************************************************/
void 
showdclasses()
/* show the D-Class-structure */
{
  compdclass();
  editdcl(curlan->lmon);
  drawmenu(menu);
} /* showdclasses */

/******************************************************************/
void showmult()
{
 compmon();
 multtable(curlan->lmon,FALSE); 
 drawmenu(menu);
}

/******************************************************************/
void
showsfx()
/* tests and prints a starfree expression from curlan */
{ boole expand;
        compsfx();
	if (curlan->starfree) 
          {
           help(FALSE,"The marked language is starfree. Should the expression be expanded (y,n)");
           if(getch()=='y') expand=TRUE;
           else             expand=FALSE;
           editsfx(curlan->ldfa,curlan->lmon,curlan->sexp,expand,FALSE);
	   drawmenu(menu);
	  } 
        else 
          help(TRUE,"The marked language is not starfree. Press a key to confirm.");
} /* showsfx */
