#ifndef TWO_FACT_H
#define TWO_FACT_H

/*
   Bordeaux : 1995
   */



#include "ext.h"
#include "extbis.h"

/* This function links the following functions to compute the filed word_not_code of
   the language L (if the DFA of L is not minimal, it is minimalized) */
void two_fact_compute_word_not_code(language L);

/* Give a word of X (language of DFA X_dfa) that we know it has two factorisations */
fa_word two_fact_find_a_word_with_double_factorisation(dfa X_dfa);

/* compute a fa_word that have two factorisations on X_dfa with separators 
   (PI_SEPARATOR1 and PI_SEPARATOR2) that indicate the factors of the two 
   factorisations 
   assume that X_dfa is minimal */
fa_word two_fact_fa_word_with_two_factorisations(fa_word src, dfa X_dfa);

#endif




